#!/usr/bin/perl
#=================================================


$group_svm{"G"} = 0;
$group_svm{"A"} = 0;
$group_svm{"VI"} = 0;
$group_svm{"S"} = 0;
$group_svm{"T"} = 0;
$group_svm{"P"} = 0;
$group_svm{"FYHCWDN"} = 0;
$group_svm{"EQMKRL"} = 0;
@group = keys(%group_svm);

$aa{"G"} = 0;
$aa{"A"} = 0;
$aa{"V"} = 0;
$aa{"F"} = 0;
$aa{"I"} = 0;
$aa{"L"} = 0;
$aa{"M"} = 0;
$aa{"D"} = 0;
$aa{"E"} = 0;
$aa{"Q"} = 0;
$aa{"K"} = 0;
$aa{"R"} = 0;
$aa{"S"} = 0;
$aa{"T"} = 0;
$aa{"Y"} = 0;
$aa{"H"} = 0;
$aa{"C"} = 0;
$aa{"N"} = 0;
$aa{"W"} = 0;
$aa{"P"} = 0;
@code_aa = keys(%aa);

$randval = int(rand(10000));


if ($ARGV[0])
{
    $input = $ARGV[0];
    $fout = $ARGV[1];

}
else
{
    print "Please, enter following informations: : file.in file.out \n";
    $inputall = <STDIN>;
    chop( $inputall );
    @info = split(" ",$inputall);
    $input= $info[0];
    $fout = $info[1];
}

#REPERE les "not available" et compte les SSpins
$num = 0;
$num_entry = 1;
$SSfile = "";
open(FILE_IN,$input);
while(<FILE_IN>) {
        if (/Not available/) { 
		$SSok[$num_entry] = "No"; 
		$num_entry++;
	}
	elsif (/examples/) {$L1 = $_;}
	elsif (/dim/) {$L2 = $_;}
	elsif (/format/) {$L3 = $_;}
	elsif (/number/) {$L4 = $_;}
	else {
		$SSfile = $SSfile.$_;
		$SSok[$num_entry] = "Yes";
        	$num++;
		$num_entry++;
	}
}
close (FILE_IN);

$L4 = "number $num\n"; # reajuste le nombre d'entree
$SSfile = $L1.$L2.$L3.$L4.$SSfile;
$NB_RUN = $num;


#RUN SUR LES DIFFERENTS MODELES
foreach $name_grp (@group) {  # pour tout les noms de fichier
		$input2 = "./TRAINFILE_GROUP7/TEMP/INPUT_".$name_grp."_".$randval;
		#system "cp $input $input2";
		open(IF,"> ".$input2);
		print IF $SSfile;
		close IF;
		$file_model = "./TRAINFILE_GROUP7/TRAIN_T22_".$name_grp.".svm";
		system "./MYSVM/predict $file_model ./TRAINFILE_GROUP7/param.dat $input2 > /dev/null";
}


#RECUP RESULTAT DES 7 FICHIERS DE SORTIE

foreach $name_res (@group) {  # pour tout les noms de fichier
        $file_out = "./TRAINFILE_GROUP7/TEMP/INPUT_".$name_res."_".$randval.".pred";
	open(RES,$file_out);
	$num = 0;
	while(<RES>){
		if(/#/){$_= <RES>;}
		chop();
		$num++;
		$tabres_grp{"$name_res $num"} = $_;
	}
	close RES;
	if ($num != $NB_RUN) { print " ERROR : $num results for $NB_RUN Chemical Shifts !!\n"; }
}

# RESULTAT DANS FICHIER DE SORTIE
open(RESOUT,"> ".$fout);
$BON_RES = 0;
$BON_RES_3 = 0;
$BON_RES_2 = 0;

#for($i=1;$i<=$NB_RUN;$i++){
$j = 0;
for($i=1;$i<$num_entry;$i++){
  if($SSok[$i] eq "Yes"){
	$j++;
	foreach $name_res (@group){
		$trie{$name_res} =  $tabres_grp{"$name_res $j"};
	}
        @score_final = sort {$trie{$b} <=> $trie{$a}} keys %trie;
	$nb_entry  =  @score_final;
	$chaine_res = "$i : ";
	$vide = 1;
        for($k=0;$k<3;$k++){
		$entry =  $score_final[$k];
		$rounded = sprintf("%.2f", $trie{$entry});
		if($rounded >= 0){
			$chaine_res = $chaine_res.$entry." (".$rounded.") ";
			$vide = 0;
                 } 
	}
	#print "\n";
	if($vide == 0){ print RESOUT $chaine_res."\n";}
	else {print RESOUT $chaine_res."No result\n";}
   }
   else{
	print RESOUT "$i : No result\n";
   }
}
close RESOUT;


#CLEAN UP
foreach $name_res (@group) {  # pour tout les noms de fichier
		$file_out = "./TRAINFILE_GROUP7/TEMP/INPUT_".$name_res."_".$randval.".pred";	
		$file_in = "./TRAINFILE_GROUP7/TEMP/INPUT_".$name_res."_".$randval;	
		system "rm -f $file_out $file_in";

}




