#!/usr/bin/perl
#=================================================

$MODE_TEST="NO"; #YES or NO for test and debug

$cptres{"G"} = 0;
$cptres{"A"} = 0;
$cptres{"V"} = 0;
$cptres{"F"} = 0;
$cptres{"I"} = 0;
$cptres{"L"} = 0;
$cptres{"M"} = 0;
$cptres{"D"} = 0;
$cptres{"E"} = 0;
$cptres{"Q"} = 0;
$cptres{"K"} = 0;
$cptres{"R"} = 0;
$cptres{"S"} = 0;
$cptres{"T"} = 0;
$cptres{"Y"} = 0;
$cptres{"H"} = 0;
$cptres{"C"} = 0;
$cptres{"N"} = 0;
$cptres{"W"} = 0;
@code = keys(%cptres);

$randval = int(rand(10000));


if ($ARGV[0])
{
    $input = $ARGV[0];
    $fout = $ARGV[1];

}
else
{
    print "Please, enter following informations: : file.in file.out \n";
    $inputall = <STDIN>;
    chop( $inputall );
    @info = split(" ",$inputall);
    $input= $info[0];
    $fout = $info[1];
}

# CREATION DES FICHIER DE RESULTAT
foreach $name_res (@code) {  # pour tout les noms de fichier
                $file_name = "OUT_".$name_res."_".$randval;
                open(OUT,"> ./OUTFILE/".$file_name);
                close(OUT);
}

#CREATION DU FICHIER D'INPUT FORMATE POUR SVM
open(FILE_IN,$input);
$all_chaine = "";
$num = 0;
$max = 0;
while(<FILE_IN>) {

	if (/^$/) { next; } # on saute les lignes vides
	@item = split(" ",$_);
	$nb_entry = @item;
	$cpt_entry = 0;
	$chaine = "";
	$num++;
	$cpt_max = $nb_entry;
	if($MODE_TEST eq "YES"){ $cpt_max = $nb_entry -1;} # for TEST

	for($i=0;$i<$cpt_max;$i++){
	   if($item[$i] !~ "-"){
		$place = $i+1;
		$chaine = $chaine." ".$place." ".$item[$i];
		$cpt_entry++;
	   }
	}
	if($cpt_entry>$max){$max=$cpt_entry;}
	$chaine = $cpt_entry."  ".$chaine."\n";

	if($MODE_TEST eq "YES"){  $RESULTAT[$num] = $item[$cpt_max]; } # for TEST
	$all_chaine = $all_chaine.$chaine;
}
close FILE_IN;
open(INPUT,"> ./OUTFILE/INPUT_FILE_".$randval); 
print INPUT "$num  $max \n";
print INPUT $all_chaine; 
close INPUT;

#RUN SUR LES DIFFERENTS MODELES
$input = "../OUTFILE/INPUT_FILE_".$randval;
foreach $name_res (@code) {  # pour tout les noms de fichier
                $file_out = "../OUTFILE/OUT_".$name_res."_".$randval;
		$file_model = "../MODELFILE/MODEL_".$name_res;
		system "cd SVMTorch; ./SVMTest -sparse -no -oa $file_out  $file_model $input > /dev/null";
}

#RECUP RESULTAT DES 19 FICHIERS DE SORTIE
$NB_RUN = $num;
foreach $name_res (@code) {  # pour tout les noms de fichier
        $file_out = "./OUTFILE/OUT_".$name_res."_".$randval;
	open(RES,$file_out);
	$num = 0;
	while(<RES>){
		chop();
		$num++;
		if($MODE_TEST eq "YES"){ $vect{"$name_res $num"} = $_;} # for TEST

		# A FAIRE !!
		#$div = (1-$_)*(1-$_);
		#if($div != 0) {$tx = 1/$div} else {$tx = 0;};
		# on prend le + grand 
		$tx = $_;
		$total[$num] = $total[$num] + $tx;
		$tabres{"$name_res $num"} = $tx;
	}
	close RES;
	if ($num != $NB_RUN) { print " ERROR : $num results for $NB_RUN Chemical Shifts !!\n"; }
}

# RESULTAT DANS FICHIER DE SORTIE
open(RESOUT,"> ".$fout);
$BON_RES = 0;
$BON_RES_3 = 0;
$BON_RES_2 = 0;
for($i=1;$i<=$NB_RUN;$i++){
	foreach $name_res (@code){
		# test 1 A FAIRE !!
		#$trie{$name_res} =  (  $tabres{"$name_res $i"} / $total[$i]  ) * 100;
		# test 2
		$trie{$name_res} =  $tabres{"$name_res $i"};
	}
        @score_final = sort {$trie{$b} <=> $trie{$a}} keys %trie;

	# for TEST 
	if($MODE_TEST eq "YES"){ 
		 $TR{"$RESULTAT[$i]"} = $TR{"$RESULTAT[$i]"} + 1;	
		 if ($RESULTAT[$i] eq $score_final[0]){ 
			$BON_RES++;
			$TROK{"$RESULTAT[$i]"} = $TROK{"$RESULTAT[$i]"} + 1;
		 	#print  "$i : T:$RESULTAT[$i] R:$score_final[0]---------------------------\n";
		 }
		 $res_find{"$RESULTAT[$i] $score_final[0]"}++; #STAT res find a la place de res?

                 if (($RESULTAT[$i] eq $score_final[0]) || ($RESULTAT[$i] eq $score_final[1]) || ($RESULTAT[$i] eq $score_final[2]) ) { $BON_RES_3++; }
                 if (($RESULTAT[$i] eq $score_final[0]) || ($RESULTAT[$i] eq $score_final[1]) ) { $BON_RES_2++; }

		foreach $name_res (@code){ $vv = $vect{"$name_res $i"}; print " $i: $name_res : $vv \n"; }
		print " \n";
	}
	# FIN TEST

	$nb_entry  =  @score_final;
	$chaine_res = "$i : ";
        #for($k=0;$k<$nb_entry;$k++){
	$vide = 1;
        for($k=0;$k<5;$k++){
		$entry =  $score_final[$k];
		$rounded = sprintf("%.2f", $trie{$entry});
		if($rounded > -1.00){
			$chaine_res = $chaine_res.$entry." (".$rounded.") ";
			$vide = 0;
                 } 
	}
	if($vide == 0){ print RESOUT $chaine_res."\n";}
	else {print RESOUT $chaine_res." No result \n";}
}
close RESOUT;

# for TEST
if($MODE_TEST eq "YES"){
	foreach $name_res (@code) {  # pour tout les noms de fichier
		if($TR{"$name_res"} != 0){
			$tx =  ( $TROK{"$name_res"} / $TR{"$name_res"} ) *  100;
                	print  "Tx: $name_res : $tx %\n";
		}
          }
	 $txg =  ( $BON_RES / $NB_RUN ) * 100;
	 $txg3  =  ( $BON_RES_3 / $NB_RUN ) * 100;
	 $txg2  =  ( $BON_RES_2 / $NB_RUN ) * 100;
	 print  "Tx Global : $txg %\n";
	 print  "Tx Global (2 premier) : $txg2 %\n";
	 print  "Tx Global (3 premier) : $txg3 %\n";
}
# FIN TEST

#CLEAN UP
if($MODE_TEST eq "NO"){
	$finput = "./OUTFILE/INPUT_FILE_".$randval;
	system "rm -f $finput";
	foreach $name_res (@code) {  # pour tout les noms de fichier
		$file_out = "./OUTFILE/OUT_".$name_res."_".$randval;	
		system "rm -f $file_out";
	}
}


# CREATION GRILLE PLOTMTV
# for TEST
if($MODE_TEST eq "YES"){

	open (OUT,'>./plot.plt');

	print OUT "\$ DATA=GRID4D\n";
	print OUT "\% axisscale=f\n";
	print OUT "\% meshplot\n";
	print OUT "\% NX=21 XMIN=0 XMAX=20 \n";
	print OUT "\% NY=21 YMIN=0 YMAX=20 \n";
	print OUT "\% NZ=2 ZMIN=0 ZMAX=0.5 \n";
	print OUT "\% toplabel =  \"Sortie SVM \n";
	print OUT "\% subtitle =  \"Efficacite Totale: ",$txg,"\n";
	print OUT "\% xlabel = \" Residus Trouves \"\n";
	print OUT "\% ylabel = \" Residus Cibles \"\n\n";

	$j = 0;
        foreach $name_res (@code) {  $j++; print OUT "\% yticklabel = \($j \"$name_res\"\)\n"; }
	print OUT "\n";
	$j = 0;
        foreach $name_res (@code) {  $j++; print OUT "\% xticklabel = \($j \"$name_res\"\)\n"; }
	print OUT "\n";
	for($i = 0; $i<21; $i++){ print OUT "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n"; }
	print OUT "\n";
	print OUT " 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n";
	
	foreach $name_res (@code) {
                print OUT "\n";
                print OUT " 0 ";
		foreach $res_find (@code) {

                        if($TR{"$name_res"} != 0){
                                $nbcalc = ($res_find{"$name_res $res_find"} / $TR{"$name_res"})*100;
                                $all_stat{"$name_res $res_find"} = $nbcalc;
                        }else {  $all_stat{"$name_res $res_find"} = 0; }
                        $nom = $res_find;
                        $resu = $all_stat{"$name_res $res_find"};
                        print OUT " ",$resu," ";
                        #print "res_cible : ",$name_res," res_trouve",$nom," somme : ",$all_stat{"$name_res $res_find"},"\n";



		}
		print OUT " 0 \n";
	}
	print OUT " 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n";
	print OUT "\n";
	print OUT "\$ END\n";
	close OUT;
	$result = system("/PROG/LINUX/prog/plotmtv-1.4.1/Bin/plotmtv ./plot.plt");

}
# FIN TEST

