#!/usr/bin/perl
#=================================================


$cptres{"G"} = 0;
$cptres{"A"} = 0;
$cptres{"VI"} = 0;
$cptres{"S"} = 0;
$cptres{"T"} = 0;
$cptres{"P"} = 0;
$cptres{"FYHCWDN"} = 0;
$cptres{"EQMKRL"} = 0;
@code = keys(%cptres);


$randval = int(rand(10000));


if ($ARGV[0])
{
    $input = $ARGV[0];
    $fout = $ARGV[1];

}
else
{
    print "Please, enter following informations: : file.in file.out \n";
    $inputall = <STDIN>;
    chop( $inputall );
    @info = split(" ",$inputall);
    $input= $info[0];
    $fout = $info[1];
}

#RUN SUR LES DIFFERENTS MODELES
foreach $name_res (@code) {  # pour tout les noms de fichier
		$input2 = "./TEMP/INPUT_".$name_res."_".$randval;
		system "cp $input $input2";
		$file_model = "./TRAIN_T22_".$name_res.".svm";
		system "../MYSVM/predict $file_model predict-param.dat $input2 > /dev/null";
}


# On compte le nbre d'entrees de $input
$num = 0;
open(FILE_IN,$input);  while(<FILE_IN>) { if (/^$/) { next; } $num++;} close (FILE_IN);$NB_RUN = $num-4;
#RECUP RESULTAT DES 19 FICHIERS DE SORTIE

foreach $name_res (@code) {  # pour tout les noms de fichier
        $file_out = "./TEMP/INPUT_".$name_res."_".$randval.".pred";
	open(RES,$file_out);
	$num = 0;
	while(<RES>){
		if(/#/){$_= <RES>;}
		chop();
		$num++;
		$tabres{"$name_res $num"} = $_;
	}
	close RES;
	if ($num != $NB_RUN) { print " ERROR : $num results for $NB_RUN Chemical Shifts !!\n"; }
}

# RESULTAT DANS FICHIER DE SORTIE
open(RESOUT,"> ".$fout);
$BON_RES = 0;
$BON_RES_3 = 0;
$BON_RES_2 = 0;

for($i=1;$i<=$NB_RUN;$i++){
	foreach $name_res (@code){
		$trie{$name_res} =  $tabres{"$name_res $i"};
	}
        @score_final = sort {$trie{$b} <=> $trie{$a}} keys %trie;
	$nb_entry  =  @score_final;
	$chaine_res = "$i : ";
	$vide = 1;
        for($k=0;$k<3;$k++){
		$entry =  $score_final[$k];
		$rounded = sprintf("%.2f", $trie{$entry});
 		#print "-$i-$entry=> $rounded\n";
		if($rounded >= 0){
			$chaine_res = $chaine_res.$entry." (".$rounded.") ";
			$vide = 0;
                 } 
	}
	#print "\n";
	if($vide == 0){ print RESOUT $chaine_res."\n";}
	else {print RESOUT $chaine_res."No result\n";}
}
close RESOUT;


#CLEAN UP
#foreach $name_res (@code) {  # pour tout les noms de fichier
#		$file_out = "./TEMP/INPUT_".$name_res."_".$randval.".pred";	
#		$file_in = "./TEMP/INPUT_".$name_res."_".$randval;	
#		system "rm -f $file_out $file_in";

#}




