#!/usr/bin/perl
#=================================================
# sstype: run rescue v1, v1.2 ,rescue 2, Platon and SVM for typing
#=================================================
# INSERT HERE YOUR INSTALLATION DIRECTORY
$CRAACKDIR = "/home/jluc/TYPING/CRAACK-FTP";
#
#
# DO NOT CHANGE ANYTHING AFTER THIS LINE
$randow = int(rand(10000));
$INPFILE1 =  "$CRAACKDIR/RESCUE1/INPUT/input.cs.$randow";
$RESFILE1 = "$CRAACKDIR/RESCUE1/RESULTS/output.res.$randow";
$INPFILE1N = "$CRAACKDIR/RESCUE1N/INPUT/input.cs.$randow";
$RESFILE1N = "$CRAACKDIR/RESCUE1N/RESULTS/output.res.$randow";
$INPFILE2 = "$CRAACKDIR/RESCUE2/INPUT/input.cs.$randow";
$RESFILE2 = "$CRAACKDIR/RESCUE2/RESULTS/input.cs.res.$randow";
$INPFILEP = "$CRAACKDIR/PLATON/Platon/input.in.$randow";
$RESFILEP = "$CRAACKDIR/PLATON/Platon/output.out.$randow";
$INPFILESVM = "$CRAACKDIR/SVM/INPUT/input.svm.$randow";
$RESFILESVM = "$CRAACKDIR/SVM/RESULTS/output.svm.$randow";
$INPFILE2SVM = "$CRAACKDIR/VOTE/CONSENSUS_MySVM/inputTest.svm.$randow";
$FILE_OUT_SVM_C = "$CRAACKDIR/VOTE/CONSENSUS_MySVM/outputTest.svm.$randow";

# 3 AND 1 LETTER TAB ASSOCIATION
$code{"GLY"} = "G";
$code{"ALA"} = "A";
$code{"VAL"} = "V";
$code{"PHE"} = "F";
$code{"ILE"} = "I";
$code{"LEU"} = "L";
$code{"PRO"} = "P";
$code{"MET"} = "M";
$code{"ASP"} = "D";
$code{"GLU"} = "E";
$code{"GLN"} = "Q";
$code{"LYS"} = "K";
$code{"ARG"} = "R";
$code{"SER"} = "S";
$code{"THR"} = "T";
$code{"TYR"} = "Y";
$code{"HIS"} = "H";
$code{"CYS"} = "C";
$code{"ASN"} = "N";
$code{"TRP"} = "W";
@code = keys(%code);

$R1{"G"} = "G";
$R1{"A"} = "A";
$R1{"V"} = "V";
$R1{"F"} = "FYWHC";
$R1{"I"} = "I";
$R1{"L"} = "L";
$R1{"M"} = "M";
$R1{"D"} = "DN";
$R1{"E"} = "EQ";
$R1{"Q"} = "EQ";
$R1{"K"} = "K";
$R1{"R"} = "R";
$R1{"S"} = "S";
$R1{"T"} = "T";
$R1{"Y"} = "FYWHC";
$R1{"H"} = "FYWHC";
$R1{"C"} = "FYWHC";
$R1{"N"} = "DN";
$R1{"W"} = "FYWHC";
@R1 = keys(%R1);

$R1N{"G"} = "G";
$R1N{"A"} = "A";
$R1N{"V"} = "IV";
$R1N{"F"} = "FYWHDNC";
$R1N{"I"} = "IV";
$R1N{"L"} = "LKREQM";
$R1N{"M"} = "LKREQM";
$R1N{"D"} = "FYWHDNC";
$R1N{"E"} = "LKREQM";
$R1N{"Q"} = "LKREQM";
$R1N{"K"} = "LKREQM";
$R1N{"R"} = "LKREQM";
$R1N{"S"} = "S";
$R1N{"T"} = "T";
$R1N{"Y"} = "FYWHDNC";
$R1N{"H"} = "FYWHDNC";
$R1N{"C"} = "FYWHDNC";
$R1N{"N"} = "FYWHDNC";
$R1N{"W"} = "FYWHDNC";
@R1N = keys(%R1N);

# GET INPUT 
if ($ARGV[0])

{
    $input = $ARGV[0];
    $mode_input = $ARGV[1];
}
else
{
    print "Input file including chemicals shifts and mode\n";
    $inputall = <STDIN>;
    chop( $input );
    @info = split(" ",$inputall);
    $input = $info[0];
    $mode_input = $info[1];

}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# SELECT RUN MODE
#$MODE = $mode_input; 	# Mode donnee en entree
#$MODE = "APP"; 	# Mode de creation des fichiers d'apprentissage
$MODE = "RUN"; 		# Mode d'utilisation normal 
$RUN_PLATON = "NO";	
#$MODE = "TEST"; 	# Mode permettant les statistique
#$PLOT = 1; 		# Statistique + Plot ( avec mode "TEST" )
$PLOT = 0;  		# Pas de Statistique Plot
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# MAKE INPUT FILES FOR TYPING TOOLS
$cpt = 0;
$cptR1 = 0;
$cptR1N = 0;
$cptR2 = 0;
$cptP=0;
$Tab= " ";
$cptSVM=0;
$resultat_ok=0;
open(FILE_IN,$input);
        # on decoupe le fichier input en colonnes
        $_=<FILE_IN>; # premiere ligne : H        N       HA     HA2      HB      HB2....
        @col= split(" ",$_);
        $cpt=0;
        while(<FILE_IN>) # pour tout les systemes de spin
        {

		$sys_spin = $_;
		chop($sys_spin);
		$tab_spin_system[$cpt] = $sys_spin;
		
		#format du fichier d'entree RESCUE2
		$retR2 = &Rescue2_possible($sys_spin);
		    if ($retR2 eq "incomplet") {
		    	$input_ok_R2[$cpt]="no";
		    }
		    else{
			$input_ok_R2[$cpt]="yes";
			$TAB2[$cptR2]= $retR2;
			$cptR2++;
		    }
		
		 #format du fichier d'entree RESCUE1
		$retR1 = &Rescue1_possible($sys_spin);
		if ($retR1 eq "incomplet") {
		    	$input_ok_R1[$cpt]="no";
		    }
		else{
			$input_ok_R1[$cpt]="yes";
			$TAB1[$cptR1]= $retR1;
			$cptR1++;
		    }
	
		 #format du fichier d'entree RESCUE1N
		 $retR1N = &Rescue1N_possible($sys_spin);
		 if ($retR1N eq "incomplet") {
		    	$input_ok_R1N[$cpt]="no";
		    }
		 else{
			$input_ok_R1N[$cpt]="yes";
			$TAB1N[$cptR1N]= $retR1N;
			$cptR1N++;
		    }
		
		 # affichage du resultat
		
   	          @shift = split(" ",$sys_spin);
		  $nbcol=@shift;
		  if ($nbcol == 13){$resultat[$cpt] = $shift[12];$resultat_ok=1;$RES_EXIST = "YES";}
		
		# format du fichier d'entree PLATON
		if ($RUN_PLATON eq "YES"){
		  $retP = &PLATON_possible($sys_spin);
		  if ($retP eq "incomplet") {
		    $input_ok_P[$cpt] = "no";
		  }
		  else {
		       $input_ok_P[$cpt]="yes";
		       $TABP[$cptP] = $retP;
		       $cptP++;
		  }
		}
		
	       #format du fichier d'entree SVM
	       chop($sys_spin);
	       $retSVM = &SVM_possible($sys_spin);
	       if ($retSVM eq "incomplet") {
	       		$input_ok_SVM[$cpt] = "no";
	       }
	       else {
	       		$input_ok_SVM[$cpt]="yes";
	       	      	$TABSVM[$cptSVM] = $retSVM;
	       	       	$cptSVM++;
	       }
	$cpt++;
        }
close FILE_IN;

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#  CREATION INPUT FILE

open(INP1,'>'.$INPFILE1); foreach $cs (@TAB1) { print INP1 $cs,"\n";  } close INP1;
open(INP2,'>'.$INPFILE2); foreach $cs (@TAB2) { print INP2 $cs,"\n";  } close INP2;
open(INP1N,'>'.$INPFILE1N); foreach $cs (@TAB1N) { print INP1N $cs,"\n";  } close INP1N;
if ($RUN_PLATON eq "YES"){ 
	open(INPP,'>'.$INPFILEP); foreach $cs (@TABP) { print INPP $cs, "\n";   } close INPP;
}
open(INPSVM,'>'.$INPFILESVM); foreach $cs (@TABSVM) { print INPSVM $cs, "\n"; } close INPSVM;


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#  RUN RESCUE 1, 1N, 2, PLATON AND SVM

#print" Running RESCUE 1...\n";
system("$CRAACKDIR/RESCUE1/rescue $INPFILE1 > $RESFILE1");
#print" Running RESCUE 2...\n";
system("cd $CRAACKDIR/RESCUE2; ./run_rescue2.sh $INPFILE2 $RESFILE2");
#print" Running RESCUE 1N...\n";
system("$CRAACKDIR/RESCUE1N/rescue1N $INPFILE1N > $RESFILE1N");
if ($RUN_PLATON eq "YES"){
	#print " Running PLATON ...\n";
	system("cd $CRAACKDIR/PLATON/Platon; ./run_platon $INPFILEP $RESFILEP 1  > /usr/tmp/platon.log");  # > /dev/null
}
#print " Running SVM...\n";
system("cd $CRAACKDIR/SVM; ./run_svm_typing.pl $INPFILESVM $RESFILESVM");


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#  GET RESULTS FROM TYPING TOOLS
#  MERGE RESCUE 1, 1N, 2, PLATON, SVM
#
#
# RESCUE2
open(RES2,$RESFILE2);
$cptl = 0;
while(<RES2>){
	chop;
	@type = split(":",$_);
	$tab_res_2[$cptl] = $type[1];
	$cptl ++;
}
close RES2;

#SVM
open(RESSVM,$RESFILESVM);
$cptl=0;
while (<RESSVM>) {
       chop;
       @SVMres = split(":",$_);
       $tab_res_SVM[$cptl] = $SVMres[1];
       $cptl++;
}

close RESSVM;

# RESCUE1
open(RES1,$RESFILE1);
$cptl = 0;
while(<RES1>){
        if (/Result/)  {
		
			@item = split(":",$_);
			$repR1 = $item[1];
		        $tab_res_1[$cptl] = $repR1;
	                $cptl ++;
	}       	
}
close RES1;

# RESCUE1N
open(RES1N,$RESFILE1N);
$cptl = 0;
while(<RES1N>){
        if (/Result	/) {
                @item = split(" ",$_);
                $res = $item[3];
        }
        if (/Reliability/) {
                @item = split(" ",$_);
                $rel = "(".$item[3].")";
        $tab_res_1N[$cptl] = $res." ".$rel;
        $cptl ++;
        }
}
close RES1N;

# PLATON
if ($RUN_PLATON eq "YES"){
  open (PLATON,$RESFILEP);
  $cptl = 0;
  while (<PLATON>) {
          if (/^$/) {next;}
          if (/pattern/) {
          	$tab_res_PL[$cptl] = $_;
          	$cptl ++;
          }
          else{
                  @itemP = split(":",$_);
                  @item1P = split (",",$itemP[1]);
                  $nb = @item1P;
                  $chaineP ="";
          	  %PLTAB = ();
             for ($k=1;$k<$nb;$k++) {
                 @item3P = split(" ",$item1P[$k]);
                 #PAS DE STRUCT II
                 chop($item3P[0]);
                 $PLTAB{$item3P[0]} = $PLTAB{$item3P[0]} + $item3P[1];
                 #$chaineP = $chaineP." ".$item3P[0]." (".$item3P[1].")";
              }
              @PLTAB_ordre = sort {$PLTAB{$b} <=> $PLTAB{$a}} keys %PLTAB;
              $plnb = @PLTAB_ordre;

              for($z=0;$z<$plnb;$z++){
            	$entry = $PLTAB_ordre[$z];
            	$chaineP = $chaineP.$entry." (".$PLTAB{$entry}.") ";
              }
              $tab_res_PL[$cptl] = $chaineP."\n";
              $cptl ++;
             }
  }#end while
  close PLATON;
}
	


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# STATISTIQUES ET CONSENSUS



               $cptR1=0;
               $cptR1N=0;
               $cptR2=0;
               $cptP=0;
               $cptSVM=0;
               $cptCONS =0;

               foreach $j (@code){
		 	$Tabres_okR2{$code{$j}} =0;
		 	$Tabres_okPL{$code{$j}} = 0;
		 	$Tabres_okR1N{$code{$j}} = 0;
		 	$Tabres_okR1{$code{$j}} = 0;
		 	$Tabres_okSVM{$code{$j}} = 0;
		 }
		
		
	      %Tabconsensus = ();
              # POUR CHAQUE SYSTEME DE SPIN TESTES	
              for($i=0;$i<$cpt;$i++){

		 foreach $j (@code){
		 	$tabscore{$code{$j}} = 0;
		 }


              #resultats donnes par RESCUE1

                 if ($input_ok_R1[$i] eq "yes"){ # si Spin System a ete teste par rescue1	
                     $Tabconsensus{"R1 $i"} = $tab_res_1[$cptR1];
		     $cptR1++;
                 } else { $Tabconsensus{"R1 $i"} = "Not available";}


               # resultats donnes par RESCUE1N

               if($input_ok_R1N[$i] eq "yes"){
                   # CALCUL CONSENSUS   LKREQM (56)
                   $Tabconsensus{"R1N $i"} = $tab_res_1N[$cptR1N];
		   $cptR1N++;
                 }
                 else{ $Tabconsensus{"R1N $i"} = "Not available"; }


               #resultats donnes par RESCUE2

              	if($input_ok_R2[$i] eq "yes"){
                    #calcul CONSENSUS [RESCUE 2]: G (0.92) S (0.07)
                    $Tabconsensus{"R2 $i"} = $tab_res_2[$cptR2];
                    $cptR2++;

                 }else{$Tabconsensus{"R2 $i"} = "Not available";}


               #resultats donnes par SVM

	       if($input_ok_SVM[$i] eq "yes"){
        	      $_ = $tab_res_SVM[$cptSVM];
          	    if (/result/){$cptSVM++;$Tabconsensus{"SVM $i"} ="Not available";}
            	    else{
                   	#calcul CONSENSUS SVM
               		 $Tabconsensus{"SVM $i"} = $tab_res_SVM[$cptSVM];
                	$cptSVM++;
              	    }
               } else { $Tabconsensus{"SVM $i"} ="Not available";}


               #resultats donnes par PLATON
		if ($RUN_PLATON eq "YES"){
   			if($input_ok_P[$i] eq "yes"){
   		   	$_ = $tab_res_PL[$cptP];
   		   	if (/pattern/){$cptP++;$Tabconsensus{"PLATON $i"} ="Not available";}
   		   	else{
                 		#calcul CONSENSUS PLATON
                     		$Tabconsensus{"PLATON $i"} = $tab_res_PL[$cptP];
                     		$cptP++;
                   	}
                 	}else{ $Tabconsensus{"PLATON $i"} ="Not available";}
		}
                if ($RES_EXIST eq "YES") { $Tabconsensus{$i} = $resultat[$i];}

       }#end for


	# RUN SVM_CONSENSUS

                $reftab  = \%Tabconsensus;
		if($MODE eq 'APP'){ &make_output_learn($cpt,$reftab); }
		&run_SVM_consensus($cpt,$reftab);
                open (RSVM,$FILE_OUT_SVM_C);
                while(<RSVM>){
                   if(!/No result/){
                        @item = split(":",$_);
                        $ind = $item[0]-1;
                        $tabsvm[$ind] = $item[1];
                   }
                   else{
                        @item = split(":",$_);
                        $ind = $item[0]-1;
                        $tabsvm[$ind] = $item[1];
                   }
                }
                close(RSVM);



                # RUNNING VOTE AND CSI AND PRINT RESULT
		print "\nNum	Modules 	 Results	\n";
       		for($i=0;$i<$cpt;$i++){
			 $AFF_NUM = $i;
			 @vs = split(" ",$tab_spin_system[$i]);
			 $nvs = @vs;
			 $AFF_SHIFT = "(";
			 for($t=0;$t<$nvs;$t++){ if (($vs[$t] ne "") && ($vs[$t] ne "-")) {$AFF_SHIFT = $AFF_SHIFT.$vs[$t]."; ";} }
			 $AFF_SHIFT = $AFF_SHIFT.")";
			 #if ($RES_EXIST eq "YES") { $AFF_SHIFT = $AFF_SHIFT.$Tabconsensus{$i}.")";} else { $AFF_SHIFT = $AFF_SHIFT.")";}
			 
         	         #$AFF_SHIFT = "(".$tab_spin_system[$i].")"; # affiche Deplacement Chimique    		
			 #$AFF_SHIFT =~ s/ *- */";"/eg;

        		 $val = $Tabconsensus{"R1 $i"};
        		 if($val ne 'Not available'){chop($val);}
			 $AFF_R1 = $val; 
        		 # print "[RESCUE1]:$val\n";

        		 $val = $Tabconsensus{"R1N $i"};
			 $AFF_R1N = $val;
        		 #print "[RESCUE1N]: $val\n";

                  	 $val = $Tabconsensus{"R2 $i"};
			 if ($val eq " ") { $AFF_R2 = " Not available"; }
                         else {
			 	@av = split(" ",$val); $nv = @av;
			 	if($nv < 6){$AFF_R2  = $val;} #moins de 3 sorties
			 	else{$AFF_R2 = " ".$av[0]." ".$av[1]." ".$av[2]." ".$av[3]." ".$av[4]." ".$av[5];}
			 }
                 	 #print "[RESCUE2]:$val\n";

			if ($RUN_PLATON eq "YES"){

                 	 	$val = $Tabconsensus{"PLATON $i"};
                	 	if($val ne 'Not available'){
					chop($val);
					$val = &trois2un($val);	
			 	}
                         	@av = split(" ",$val); $nv = @av;
                         	if($nv < 6){$AFF_PL  = $val;} #moins de 3 sorties
                         	else{$AFF_PL = $av[0]." ".$av[1]." ".$av[2]." ".$av[3]." ".$av[4]." ".$av[5];}
			 	#$AFF_PL = $val;
                	 	#print "[PLATON]: $val\n";
			}

                	 $val = $Tabconsensus{"SVM $i"};
                         @av = split(" ",$val); $nv = @av;
                         if($nv < 6){$AFF_SVMt  = $val;} #moins de 3 sorties
                         else{$AFF_SVMt = " ".$av[0]." ".$av[1]." ".$av[2]." ".$av[3]." ".$av[4]." ".$av[5];}
			 #$AFF_SVMt = $val;
                	 #print "[SVM]:$val\n";

                         $val = $tabsvm[$i];
			 chop($val);
			 $AFF_SVMc = $val;
                         #print "\n[CONSENSUS GROUP (SVM Algorithm)]: $val";

                # RUNNING VOTE AND CSI FUNCTION
                	  $valR1= $Tabconsensus{"R1 $i"};
                	  $valR1N= $Tabconsensus{"R1N $i"};
                	  $valR2 = $Tabconsensus{"R2 $i"}; if ($valR2 eq " ") { $valR2 = "Not available"; }
                	  if ($RUN_PLATON eq "YES"){ $valP = $Tabconsensus{"PLATON $i"}; } else { $valP = "Not available"; }
                	  $valSVM = $Tabconsensus{"SVM $i"};
                	  $valConsSVM = $tabsvm[$i];
                	  $val = &vote($valR1,$valR1N,$valR2,$valP,$valSVM,$valConsSVM);
			  $AFF_VOTE = $val;
               	          #print "[CONSENSUS (Vote Algorithm)]: $val\n";

			  #RUN CSI
			  if ($AFF_VOTE eq "No result ") { $AFF_CSI = "No result ";}
			  else{
			  	$AFF_CSI = &run_csi($tab_spin_system[$i],$AFF_VOTE); 
			  	$AFF_VOTE =~ s/-/" "/eg;
			  	#$AFF_VOTE =~ s/P/"?"/eg;
			  }

			$AFF_NUM2 = $AFF_NUM + 1;
			print "\n$AFF_NUM2	[Input Shifts]:  $AFF_SHIFT\n";	
			print "	[Rescue1]:	$AFF_R1\n";	
			print "	[Rescue1N]:	 $AFF_R1N\n";
		 	print "	[Rescue2]:	$AFF_R2\n";
			if ($RUN_PLATON eq "YES"){
				print "	[Platon]:  	 $AFF_PL\n";
			}
			print "	[SVMTyping]:	$AFF_SVMt\n";
			print "	\n";
			print "	[SVM Consensus]:$AFF_SVMc\n";
			print "	[Vote Consensus]:$AFF_VOTE\n";
			print "	[CSI]:           $AFF_CSI\n";
			print "	\n";

			# CALC COMPLETE PRIMARY SEQUENCE
			if ($AFF_VOTE eq "No result ") { $r = "-"; $s = "-";} 
			else { 
				$r = substr($AFF_VOTE,0,1);
				@ttab = split("\\(",$AFF_VOTE);
				@ttab2 = split("\\)",$ttab[1]);
				$st = ( ($ttab2[0] / 6.8 ) * 9 ) / 10;
				$s = sprintf ("%.1f",$st); $s = $s * 10; 
			}
			$score_aa = $score_aa.$s;
			$primary_seq = $primary_seq.$r;

			if ($AFF_CSI eq "No result ") { $c = "-";  $sc = "-";} 
			else {
				$c = substr($AFF_CSI,0,1);
				if($c eq "C"){ $c= " ";}
                                @ttab = split("\\(",$AFF_CSI);
                                @ttab2 = split("\\)",$ttab[1]);
                                $sc = abs($ttab2[0]); 

			} 
			$primary_csi = $primary_csi.$c;
			$score_csi = $score_csi.$sc;

       		}

	# PRINT COMPLETE PRIMARY SEQUENCE
	print "\n\n";
	print "SEQ:".$primary_seq."\n";
	print "SCO:".$score_aa."\n";
	print "CSI:".$primary_csi."\n";
	print "SCO:".$score_csi."\n";


#  CLEAN TEMP FILES
system "rm -f $INPFILE1 $RESFILE1 $INPFILE1N $RESFILE1N $INPFILE2 $RESFILE2 $INPFILEP $RESFILEP $INPFILESVM $RESFILESVM";
system "rm -f $INPFILE2SVM $FILE_OUT_SVM_C";



     ###########################################################################################
     #definition de fonctions
     ###########################################################################################
     ###########################################################################################
     ###########################################################################################
     #fonction valable pour RESCUE2	

     	
     sub Rescue2_possible
     {

       local($input)=@_;

       @shift = split (" ",$input);
		 chop;
		

     $chaine = "";
     $nbsh = 0;
		if ($shift[1]!="-") {$chaine = $chaine."N: ".$shift[1];$nbsh++;}
		
		if (($shift[0]!="-")||($shift[2]!="-") || ($shift[3]!="-") || ($shift[4]!="-") || ($shift[5]!="-")||($shift[6]!="-")){$chaine = $chaine."  H: ";}
		
		if ($shift[0]!="-") {$chaine = $chaine."  ".$shift[0];$nbsh++;}
		if ($shift[2]!="-") {$chaine = $chaine."  ".$shift[2];$nbsh++;}
		if ($shift[3]!="-") {$chaine = $chaine."  ".$shift[3];$nbsh++;}
		if (($shift[4]!="-")&&($shift[4]>0)) {$chaine = $chaine."  ".$shift[4];$nbsh++;} # cas du Hb parfois >0
		if (($shift[5]!="-")&&($shift[5]>0)) {$chaine = $chaine."  ".$shift[5];$nbsh++;}
		if (($shift[6]!="-")&&($shift[6]>0)) {$chaine = $chaine."  ".$shift[6];$nbsh++;}
		
		
	    	
		if (($shift[7]!="-")|| ($shift[8]!="-") || ($shift[9]!="-")) {$chaine = $chaine."  C: ";}
		
		
		if ($shift[7]!="-") {$chaine = $chaine."  ".$shift[7];$nbsh++;}
		if ($shift[8]!="-") {$chaine = $chaine."  ".$shift[8];$nbsh++;}
		#if ($shift[9]!="-") {$chaine = $chaine."  ".$shift[9];$nbsh++;}
		
		
		
		if($nbsh < 4){$chaine = "incomplet";}
               return $chaine;
       }

       #fonction valable pour RESCUE1

      sub Rescue1_possible
      {
      	local($input)=@_;
         @shift = split (" ",$input);
		 chop;
	$nbsh=0;	
		 $chaine=" ";
		 if ($shift[0]!="-") {$chaine = $chaine." ".$shift[0];$nbsh++;}
		 if ($shift[2]!="-") {$chaine = $chaine." ".$shift[2];$nbsh++;}
		 if ($shift[3]!="-") {$chaine = $chaine." ".$shift[3];$nbsh++;}
		 if ($shift[4]!="-") {$chaine = $chaine." ".$shift[4];$nbsh++;}
		 if ($shift[5]!="-") {$chaine = $chaine." ".$shift[5];$nbsh++;}
		 if ($shift[6]!="-") {$chaine = $chaine." ".$shift[6];$nbsh++;}
					
		 if ($nbsh < 3) {$chaine = "incomplet";}
                 return $chaine;


                 }



      # fonction valable pour RESCUE 1N

        sub Rescue1N_possible
        {
            local($input)=@_;
            @shift = split (" ",$input);
		 chop;
	 $nbsh=0;	
		
		$chaine=" ";
		if ($shift[1]!="-") {$chaine = $chaine." ".$shift[1];$nbsh++;}
		if ($shift[0]!="-") {$chaine = $chaine." ".$shift[0];$nbsh++;}
		if ($shift[2]!="-") {$chaine = $chaine." ".$shift[2];$nbsh++;}
		if ($shift[3]!="-") {$chaine = $chaine." ".$shift[3];$nbsh++;}
		if ($shift[4]!="-") {$chaine = $chaine." ".$shift[4];$nbsh++;}
		if ($shift[5]!="-") {$chaine = $chaine." ".$shift[5];$nbsh++;}
		if ($shift[6]!="-") {$chaine = $chaine." ".$shift[6];$nbsh++;}
		
		if ($nbsh < 3) {$chaine = "incomplet";}
		if ($shift[1] eq "-"){$chaine = "incomplet";}
				
                 return $chaine;


              }


       #fonction valable pour PLATON

       sub PLATON_possible
       {

           local($input)=@_;
           @shift = split (" ",$input);
           chop;
        $nbsh = 0;
        $chaine1 = " ";
        $chaine2 = " ";
        $chaine = " ";
        if ($shift[0]!="-")  {
           $chaine1 = $chaine1."H;";
           $chaine2 = $chaine2.$shift[0];$nbsh++;

      }

        if ($shift[1]!="-") {
            $chaine1 = $chaine1."N;";
            $chaine2 = $chaine2." ".$shift[1];$nbsh++;

      }
        if ($shift[2]!="-")  {
             $chaine1 = $chaine1."HA;";
             $chaine2 = $chaine2." ".$shift[2];$nbsh++;
      }
        if ($shift[4]!="-") {
             $chaine1 = $chaine1."HB;";
             $chaine2 = $chaine2." ".$shift[4];$nbsh++;
      }
        if ($shift[7]!="-"){
             $chaine1 = $chaine1."CA;";
             $chaine2 = $chaine2." ".$shift[7];$nbsh++;

      }
        if ($shift[8]!="-") {
             $chaine1 = $chaine1."CB;";
             $chaine2 = $chaine2." ".$shift[8];$nbsh++;

      }



      $chaine =  $chaine1." ".":".$chaine2;

       if ($nbsh < 2 ) {$chaine = "incomplet";}
       if (($shift[0]!="-") && ($shift[1]!="-") && ($shift[2]!="-") &&  ($shift[4] eq "-") && ($shift[7] eq "-") && ($shift[8] eq "-")) {$chaine = "incomplet";}
       if ($shift[8] eq "-") {$chaine = "incomplet";}
     return $chaine;

  }

  #fonction valable pour SVM
  sub SVM_possible {
  local($input)=@_;
    @shift = split(" ",$input);
    $chaine = " ";


   $chaine = $shift[0]." ".$shift[1]." ".$shift[2]." ".$shift[3]." ".$shift[4]." ".$shift[5]." ".$shift[6]." ".$shift[7]." ".$shift[8]."  - \n";


   return $chaine;
  }#end sub SVM


#RUN SVM CONSENSUS
sub run_SVM_consensus{

        my ($cpt,$Tab) = @_;

        $dmax = 86;
        open(INPUT,'> '.$INPFILE2SVM);
        print INPUT "\@examples\n";
        print INPUT "dim $dmax\n";
        print INPUT "format sparse\n";
        print INPUT "number $cpt\n";

     for($i=0;$i<$cpt;$i++){

                #RAZ
                $d = 0; $chainescore = "";$d_local = 0;


         # RESCUE1
         $Rescue1{'IL'} = 0;
         $Rescue1{'I'} = 0;
         $Rescue1{'L'} = 0;
         $Rescue1{'A'} = 0;
         $Rescue1{'G'} = 0;
         $Rescue1{'P'} = 0;
         $Rescue1{'T'} = 0;
         $Rescue1{'V'} = 0;
         $Rescue1{'KR'} = 0;
         $Rescue1{'K'} = 0;
         $Rescue1{'R'} = 0;
         $Rescue1{'FYWHCDN'} = 0;
         $Rescue1{'FYWHC'} = 0;
         $Rescue1{'DN'} = 0;
         $Rescue1{'EQM'} = 0;
         $Rescue1{'EQ'} = 0;
         $Rescue1{'M'} = 0;
         $Rescue1{'S'} = 0;



           if($Tab->{"R1 $i"} ne 'Not available'){
                # LEARN FILE RESCUE1
                $ligne_out =  $Tab->{"R1 $i"};
                $_ =  $Tab->{"R1 $i"};
                # ON RECUPERE L'ACIDE AMINE
                if (/->/){
                  @itemR1 = split("-> ",$ligne_out);
                  @item1R1 = split(" \\(",$itemR1[1]);
                  $res = $item1R1[0];
                  @item2R1 = split("\\)",$item1R1[1]);
                  $Rescue1{$res}= $item2R1[0];
                  #$Rescue1{$res}= sprintf ("%.2f",$item2R1[0]);
                  @item1G1 = split(" \\(",$itemR1[0]);
                  $resG = $item1G1[0];
                  $resG = substr($resG,1);
                  @item2G1 = split("\\)",$item1G1[1]);
                  $Rescue1{$resG} = $item2G1[0];
                  #$Rescue1{$resG}= sprintf ("%.2f",$item2G1[0]);
                 }

                else {
                  @item3R1 = split(" \\(",$ligne_out);
                  $res = $item3R1[0];
                  $res = substr($res,1);
                  @item4R1 = split("\\) ",$item3R1[1]);
                  $Rescue1{$res} = $item4R1[0];
                  #$Rescue1{$res}=sprintf ("%.2f",$item4R1[0]);
                }

                if($Rescue1{'IL'} != 0){$chainescore = $chainescore."1:$Rescue1{'IL'} "; $d_local++;}
                if($Rescue1{'I'} != 0){$chainescore = $chainescore."2:$Rescue1{'I'} "; $d_local++;}
                if($Rescue1{'L'} != 0){$chainescore = $chainescore."3:$Rescue1{'L'} "; $d_local++;}
                if($Rescue1{'A'} != 0){$chainescore = $chainescore."4:$Rescue1{'A'} "; $d_local++;}
                if($Rescue1{'G'} != 0){$chainescore = $chainescore."5:$Rescue1{'G'} "; $d_local++;}
                if($Rescue1{'P'} != 0){$chainescore = $chainescore."6:$Rescue1{'P'} "; $d_local++;}
                if($Rescue1{'T'} != 0){$chainescore = $chainescore."7:$Rescue1{'T'} "; $d_local++;}
                if($Rescue1{'V'} != 0){$chainescore = $chainescore."8:$Rescue1{'V'} "; $d_local++;}
                if($Rescue1{'KR'} != 0){$chainescore = $chainescore."9:$Rescue1{'KR'} "; $d_local++;}
                if($Rescue1{'K'} != 0){$chainescore = $chainescore."10:$Rescue1{'K'} "; $d_local++;}
                if($Rescue1{'R'} != 0){$chainescore = $chainescore."11:$Rescue1{'R'} "; $d_local++;}
                if($Rescue1{'FYWHCDN'} != 0){$chainescore = $chainescore."12:$Rescue1{'FYWHCDN'} "; $d_local++;}
                if($Rescue1{'FYWHC'} != 0){$chainescore = $chainescore."13:$Rescue1{'FYWHC'} "; $d_local++;}
                if($Rescue1{'DN'} != 0){$chainescore = $chainescore."14:$Rescue1{'DN'} "; $d_local++;}
                if($Rescue1{'EQM'} != 0){$chainescore = $chainescore."15:$Rescue1{'EQM'} "; $d_local++;}
                if($Rescue1{'EQ'} != 0){$chainescore = $chainescore."16:$Rescue1{'EQ'} "; $d_local++;}
                if($Rescue1{'M'} != 0){$chainescore = $chainescore."17:$Rescue1{'M'} "; $d_local++;}
                if($Rescue1{'S'} != 0){$chainescore = $chainescore."18:$Rescue1{'S'} "; $d_local++;}
          }


         #RESCUE1N
         $Rescue1N{'IV'} = 0;
         $Rescue1N{'A'} = 0;
         $Rescue1N{'G'} = 0;
         $Rescue1N{'P'} = 0;
         $Rescue1N{'T'} = 0;
         $Rescue1N{'LKREQM'} = 0;
         $Rescue1N{'FYWHDNC'} = 0;
         $Rescue1N{'S'} = 0;

         if($Tab->{"R1N $i"} ne 'Not available'){
                # LEARN FILE RESCUE R1N
                 $ligne_outR1N = $Tab->{"R1N $i"};
                 @item = split("\\(",$ligne_outR1N);
                 $res = $item[0];
                 chop($res);
                 @item2 = split("\\)",$item[1]);
                 $Rescue1N{$res} = $item2[0];
                 #$Rescue1N{$res}= sprintf ("%.2f",$item2[0]);

                if($Rescue1N{'IV'} != 0){$chainescore = $chainescore."19:$Rescue1N{'IV'} ";$d_local++;}
                if($Rescue1N{'A'} != 0){$chainescore = $chainescore."20:$Rescue1N{'A'} "; $d_local++;}
                if($Rescue1N{'G'} != 0){$chainescore = $chainescore."21:$Rescue1N{'G'} "; $d_local++;}
                if($Rescue1N{'P'} != 0){$chainescore = $chainescore."22:$Rescue1N{'P'} "; $d_local++;}
                if($Rescue1N{'T'} != 0){$chainescore = $chainescore."23:$Rescue1N{'T'} "; $d_local++;}
                if($Rescue1N{'LKREQM'} != 0){$chainescore = $chainescore."24:$Rescue1N{'LKREQM'} "; $d_local++;}
                if($Rescue1N{'FYWHDNC'} != 0){$chainescore = $chainescore."25:$Rescue1N{'FYWHDNC'} "; $d_local++;}
                if($Rescue1N{'S'} != 0){$chainescore = $chainescore."26:$Rescue1N{'S'} ";  $d_local++;}
         }


         # RESCUE 2
         $Rescue2{'A'} = 0;
         $Rescue2{'C'} = 0;
         $Rescue2{'D'} = 0;
         $Rescue2{'E'} = 0;
         $Rescue2{'F'} = 0;
         $Rescue2{'G'} = 0;
         $Rescue2{'H'} = 0;
         $Rescue2{'I'} = 0;
         $Rescue2{'K'} = 0;
         $Rescue2{'L'} = 0;
         $Rescue2{'M'} = 0;
         $Rescue2{'N'} = 0;
         $Rescue2{'P'} = 0;
         $Rescue2{'Q'} = 0;
         $Rescue2{'R'} = 0;
         $Rescue2{'S'} = 0;
         $Rescue2{'T'} = 0;
         $Rescue2{'V'} = 0;
         $Rescue2{'W'} = 0;
         $Rescue2{'Y'} = 0;


          if($Tab->{"R2 $i"} ne 'Not available'){
                 #LEARN FILE RESCUE 2
                 $ligne_outR2 = $Tab->{"R2 $i"};
                 @item3 = split ("\\) ",$ligne_outR2);
                 $nbcol = @item3;
                 for ($j =0;$j<3;$j++) {
                   if($j < $nbcol){
                      @rsc = split(" \\(",$item3[$j]);
                      if ($j==0) {$r= substr($rsc[0],1);} else {$r=$rsc[0];}
                      if($j == 0){$Rescue2{"$r"} = $rsc[1]*100;} #1ere place
                      if($j == 1){$Rescue2{"$r"} = $rsc[1]*10;} #2eme place
                      if($j == 2){$Rescue2{"$r"} = $rsc[1];} #3eme place
                      #$Rescue2{"$r"} = sprintf("%.2f",$rr);
                   }
                 }
                 if($Rescue2{'A'} != 0){$chainescore = $chainescore."27:$Rescue2{'A'} ";  $d_local++;}
                 if($Rescue2{'C'} != 0){$chainescore = $chainescore."28:$Rescue2{'C'} "; $d_local++;}
                 if($Rescue2{'D'} != 0){$chainescore = $chainescore."29:$Rescue2{'D'} "; $d_local++;}
                 if($Rescue2{'E'} != 0){$chainescore = $chainescore."30:$Rescue2{'E'} "; $d_local++;}
                 if($Rescue2{'F'} != 0){$chainescore = $chainescore."31:$Rescue2{'F'} "; $d_local++;}
                 if($Rescue2{'G'} != 0){$chainescore = $chainescore."32:$Rescue2{'G'} "; $d_local++;}
                 if($Rescue2{'H'} != 0){$chainescore = $chainescore."33:$Rescue2{'H'} "; $d_local++;}
                 if($Rescue2{'I'} != 0){$chainescore = $chainescore."34:$Rescue2{'I'} "; $d_local++;}
                 if($Rescue2{'K'} != 0){$chainescore = $chainescore."35:$Rescue2{'K'} "; $d_local++;}
                 if($Rescue2{'L'} != 0){$chainescore = $chainescore."36:$Rescue2{'L'} "; $d_local++;}
                 if($Rescue2{'M'} != 0){$chainescore = $chainescore."37:$Rescue2{'M'} "; $d_local++;}
                 if($Rescue2{'N'} != 0){$chainescore = $chainescore."38:$Rescue2{'N'} "; $d_local++;}
                 if($Rescue2{'P'} != 0){$chainescore = $chainescore."39:$Rescue2{'P'} "; $d_local++;}
                 if($Rescue2{'Q'} != 0){$chainescore = $chainescore."40:$Rescue2{'Q'} "; $d_local++;}
                 if($Rescue2{'R'} != 0){$chainescore = $chainescore."41:$Rescue2{'R'} "; $d_local++;}
                 if($Rescue2{'S'} != 0){$chainescore = $chainescore."42:$Rescue2{'S'} "; $d_local++;}
                 if($Rescue2{'T'} != 0){$chainescore = $chainescore."43:$Rescue2{'T'} "; $d_local++;}
                 if($Rescue2{'V'} != 0){$chainescore = $chainescore."44:$Rescue2{'V'} "; $d_local++;}
                 if($Rescue2{'W'} != 0){$chainescore = $chainescore."45:$Rescue2{'W'} "; $d_local++;}
                 if($Rescue2{'Y'} != 0){$chainescore = $chainescore."46:$Rescue2{'Y'} "; $d_local++;}
         }





         #PLATON
         $Platon{'A'} = 0;
         $Platon{'C'} = 0;
         $Platon{'D'} = 0;
         $Platon{'E'} = 0;
         $Platon{'F'} = 0;
         $Platon{'G'} = 0;
         $Platon{'H'} = 0;
         $Platon{'I'} = 0;
         $Platon{'K'} = 0;
         $Platon{'L'} = 0;
         $Platon{'M'} = 0;
         $Platon{'N'} = 0;
         $Platon{'P'} = 0;
         $Platon{'Q'} = 0;
         $Platon{'R'} = 0;
         $Platon{'S'} = 0;
         $Platon{'T'} = 0;
         $Platon{'V'} = 0;
         $Platon{'W'} = 0;
         $Platon{'Y'} = 0;



         if($Tab->{"PLATON $i"} ne 'Not available'){

                 #LEARN FILE PLATON
                 $ligne_outPL = $Tab->{"PLATON $i"};
                 @item4P = split ("\\) ",$ligne_outPL);
                 $nbcolP = @item4P;
                 for ($h=0;$h<3;$h++){
                   if($h<$nbcolP){
                      @resPL = split (" \\(",$item4P[$h]);
                      $rPL = $code{$resPL[0]};
                      if($h == 0){$Platon{"$rPL"} = $resPL[1]*10;}
                      if($h == 1){$Platon{"$rPL"} = $resPL[1];}
                      if($h == 2){
                         $s7 =$resPL[1];
                      	$Platon{"$rPL"} =$s7/10;
                      }
                      #$Platon{"$rPL"}= sprintf ("%.2f",$resPL[1]);
                   }
               }
               if($Platon{'A'} != 0){$chainescore = $chainescore."47:$Platon{'A'} "; $d_local++;}
               if($Platon{'C'} != 0){$chainescore = $chainescore."48:$Platon{'C'} "; $d_local++;}
               if($Platon{'D'} != 0){$chainescore = $chainescore."49:$Platon{'D'} "; $d_local++;}
               if($Platon{'E'} != 0){$chainescore = $chainescore."50:$Platon{'E'} "; $d_local++;}
               if($Platon{'F'} != 0){$chainescore = $chainescore."51:$Platon{'F'} "; $d_local++;}
               if($Platon{'G'} != 0){$chainescore = $chainescore."52:$Platon{'G'} "; $d_local++;}
               if($Platon{'H'} != 0){$chainescore = $chainescore."53:$Platon{'H'} "; $d_local++;}
               if($Platon{'I'} != 0){$chainescore = $chainescore."54:$Platon{'I'} "; $d_local++;}
               if($Platon{'K'} != 0){$chainescore = $chainescore."55:$Platon{'K'} "; $d_local++;}
               if($Platon{'L'} != 0){$chainescore = $chainescore."56:$Platon{'L'} "; $d_local++;}
               if($Platon{'M'} != 0){$chainescore = $chainescore."57:$Platon{'M'} "; $d_local++;}
               if($Platon{'N'} != 0){$chainescore = $chainescore."58:$Platon{'N'} "; $d_local++;}
               if($Platon{'P'} != 0){$chainescore = $chainescore."59:$Platon{'P'} "; $d_local++;}
               if($Platon{'Q'} != 0){$chainescore = $chainescore."60:$Platon{'Q'} "; $d_local++;}
               if($Platon{'R'} != 0){$chainescore = $chainescore."61:$Platon{'R'} "; $d_local++;}
               if($Platon{'S'} != 0){$chainescore = $chainescore."62:$Platon{'S'} "; $d_local++;}
               if($Platon{'T'} != 0){$chainescore = $chainescore."63:$Platon{'T'} "; $d_local++;}
               if($Platon{'V'} != 0){$chainescore = $chainescore."64:$Platon{'V'} "; $d_local++;}
               if($Platon{'W'} != 0){$chainescore = $chainescore."65:$Platon{'W'} "; $d_local++;}
               if($Platon{'Y'} != 0){$chainescore = $chainescore."66:$Platon{'Y'} "; $d_local++;}
         }


         # SVM
         $svm{'A'} = 0;
         $svm{'C'} = 0;
         $svm{'D'} = 0;
         $svm{'E'} = 0;
         $svm{'F'} = 0;
         $svm{'G'} = 0;
         $svm{'H'} = 0;
         $svm{'I'} = 0;
         $svm{'K'} = 0;
         $svm{'L'} = 0;
         $svm{'M'} = 0;
         $svm{'N'} = 0;
         $svm{'P'} = 0;
         $svm{'Q'} = 0;
         $svm{'R'} = 0;
         $svm{'S'} = 0;
         $svm{'T'} = 0;
         $svm{'V'} = 0;
         $svm{'W'} = 0;
         $svm{'Y'} = 0;


         if($Tab->{"SVM $i"} ne 'Not available'){
               # LEARN FILE SVM
               $ligne_outSVM = $Tab->{"SVM $i"};
               @itemSVM = split("\\) ",$ligne_outSVM);
               $nbcolS = @itemSVM;
               for ($d=0;$d<3;$d++) {
                 if($d<$nbcolS){
                   @r1 = split(" \\(",$itemSVM[$d]);
                   if ($d == 0) {$SVMr = substr($r1[0],1);} else { $SVMr = $r1[0];}
                     if($r1[1] > 0){
                        if($d==0){$svm{"$SVMr"} = $r1[1]*10;}
                        if($d==0){$svm{"$SVMr"} = $r1[1];}
                        if($d==0){
                        $s8 = $r1[1];
                        $svm{"$SVMr"} =$s8/10;}
                        #$SVMs = sprintf ("%.2f",$SVMst);
                        #$svm{"$SVMr"} = $SVMs;
                     }
                 }
               }
               if($svm{'A'} != 0){ $chainescore = $chainescore."67:$svm{'A'} "; $d_local++;}
               if($svm{'C'} != 0){ $chainescore = $chainescore."68:$svm{'C'} "; $d_local++;}
               if($svm{'D'} != 0){ $chainescore = $chainescore."69:$svm{'D'} "; $d_local++;}
               if($svm{'E'} != 0){ $chainescore = $chainescore."70:$svm{'E'} "; $d_local++;}
               if($svm{'F'} != 0){ $chainescore = $chainescore."71:$svm{'F'} "; $d_local++;}
               if($svm{'G'} != 0){ $chainescore = $chainescore."72:$svm{'G'} "; $d_local++;}
               if($svm{'H'} != 0){ $chainescore = $chainescore."73:$svm{'H'} "; $d_local++;}
               if($svm{'I'} != 0){ $chainescore = $chainescore."74:$svm{'I'} "; $d_local++;}
               if($svm{'K'} != 0){ $chainescore = $chainescore."75:$svm{'K'} "; $d_local++;}
               if($svm{'L'} != 0){ $chainescore = $chainescore."76:$svm{'L'} "; $d_local++;}
               if($svm{'M'} != 0){ $chainescore = $chainescore."77:$svm{'M'} "; $d_local++;}
               if($svm{'N'} != 0){ $chainescore = $chainescore."78:$svm{'N'} "; $d_local++;}
               if($svm{'P'} != 0){ $chainescore = $chainescore."79:$svm{'P'} "; $d_local++;}
               if($svm{'Q'} != 0){ $chainescore = $chainescore."80:$svm{'Q'} "; $d_local++;}
               if($svm{'R'} != 0){ $chainescore = $chainescore."81:$svm{'R'} "; $d_local++;}
               if($svm{'S'} != 0){ $chainescore = $chainescore."82:$svm{'S'} "; $d_local++;}
               if($svm{'T'} != 0){ $chainescore = $chainescore."83:$svm{'T'} "; $d_local++;}
               if($svm{'V'} != 0){ $chainescore = $chainescore."84:$svm{'V'} "; $d_local++;}
               if($svm{'W'} != 0){ $chainescore = $chainescore."85:$svm{'W'} "; $d_local++;}
               if($svm{'Y'} != 0){ $chainescore = $chainescore."86:$svm{'Y'} "; $d_local++;}
           }

		if ($chainescore eq ""){ $chainescore = "Not available"; }
                print INPUT "$chainescore\n";
        }
        close INPUT;
        #print " Running svm_consensus...\n";
        system("cd $CRAACKDIR/VOTE/CONSENSUS_MySVM; ./run_svm_consensus.pl $INPFILE2SVM $FILE_OUT_SVM_C");

}


# creation des fichiers permettant de realiser l'apprentissage de SVM

sub make_output_learn {

    my ($cpt,$Tab) = @_;


    $cptres{"G"} = 0;
    $cptres{"A"} = 0;
    $cptres{"V"} = 0;
    $cptres{"F"} = 0;
    $cptres{"I"} = 0;
    $cptres{"L"} = 0;
    $cptres{"M"} = 0;
    $cptres{"D"} = 0;
    $cptres{"E"} = 0;
    $cptres{"Q"} = 0;
    $cptres{"K"} = 0;
    $cptres{"R"} = 0;
    $cptres{"S"} = 0;
    $cptres{"T"} = 0;
    $cptres{"Y"} = 0;
    $cptres{"H"} = 0;
    $cptres{"C"} = 0;
    $cptres{"N"} = 0;
    $cptres{"W"} = 0;
    @code = keys(%cptres);


    $n = $cpt;
    #'APP'
    $dmax = 86;
    foreach $name_res (@code) {  # pour tout les noms de fichier
                $file_name = "TRAIN_".$name_res;
                open(OUT,"> $CRAACKDIR/VOTE/CONSENSUS_MySVM_19/TRAINFILE/".$file_name);
                print OUT "\@examples\n";
                print OUT "dim $dmax\n";
                print OUT "format sparse\n";
                print OUT "number $n\n";
                close(OUT);
     }
     $err = 0;


     for($i=0;$i<$cpt;$i++){

         #RAZ
         $d = 0; $chainescore = "";$d_local = 0;


         # RESCUE1
         $Rescue1{'IL'} = 0;
         $Rescue1{'I'} = 0;
         $Rescue1{'L'} = 0;
         $Rescue1{'A'} = 0;
         $Rescue1{'G'} = 0;
         $Rescue1{'P'} = 0;
         $Rescue1{'T'} = 0;
         $Rescue1{'V'} = 0;
         $Rescue1{'KR'} = 0;
         $Rescue1{'K'} = 0;
         $Rescue1{'R'} = 0;
         $Rescue1{'FYWHCDN'} = 0;
         $Rescue1{'FYWHC'} = 0;
         $Rescue1{'DN'} = 0;
         $Rescue1{'EQM'} = 0;
         $Rescue1{'EQ'} = 0;
         $Rescue1{'M'} = 0;
         $Rescue1{'S'} = 0;



           if($Tab->{"R1 $i"} ne 'Not available'){
                # LEARN FILE RESCUE1
                $ligne_out =  $Tab->{"R1 $i"};
                $_ =  $Tab->{"R1 $i"};
                # ON RECUPERE L'ACIDE AMINE
                if (/->/){
                  @itemR1 = split("-> ",$ligne_out);
                  @item1R1 = split(" \\(",$itemR1[1]);
                  $res = $item1R1[0];
                  @item2R1 = split("\\)",$item1R1[1]);
                  $Rescue1{$res}= $item2R1[0];
                  #$Rescue1{$res}= sprintf ("%.2f",$item2R1[0]);
                  @item1G1 = split(" \\(",$itemR1[0]);
                  $resG = $item1G1[0];
                  $resG = substr($resG,1);
                  @item2G1 = split("\\)",$item1G1[1]);
                  $Rescue1{$resG} = $item2G1[0];
                  #$Rescue1{$resG}= sprintf ("%.2f",$item2G1[0]);
                 }

                else {
                  @item3R1 = split(" \\(",$ligne_out);
                  $res = $item3R1[0];
                  $res = substr($res,1);
                  @item4R1 = split("\\) ",$item3R1[1]);
                  $Rescue1{$res} = $item4R1[0];
                  #$Rescue1{$res}=sprintf ("%.2f",$item4R1[0]);
                }


                if($Rescue1{'IL'} != 0){$chainescore = $chainescore."1:$Rescue1{'IL'} "; $d_local++;}
                if($Rescue1{'I'} != 0){$chainescore = $chainescore."2:$Rescue1{'I'} "; $d_local++;}
                if($Rescue1{'L'} != 0){$chainescore = $chainescore."3:$Rescue1{'L'} "; $d_local++;}
                if($Rescue1{'A'} != 0){$chainescore = $chainescore."4:$Rescue1{'A'} "; $d_local++;}
                if($Rescue1{'G'} != 0){$chainescore = $chainescore."5:$Rescue1{'G'} "; $d_local++;}
                if($Rescue1{'P'} != 0){$chainescore = $chainescore."6:$Rescue1{'P'} "; $d_local++;}
                if($Rescue1{'T'} != 0){$chainescore = $chainescore."7:$Rescue1{'T'} "; $d_local++;}
                if($Rescue1{'V'} != 0){$chainescore = $chainescore."8:$Rescue1{'V'} "; $d_local++;}
                if($Rescue1{'KR'} != 0){$chainescore = $chainescore."9:$Rescue1{'KR'} "; $d_local++;}
                if($Rescue1{'K'} != 0){$chainescore = $chainescore."10:$Rescue1{'K'} "; $d_local++;}
                if($Rescue1{'R'} != 0){$chainescore = $chainescore."11:$Rescue1{'R'} "; $d_local++;}
                if($Rescue1{'FYWHCDN'} != 0){$chainescore = $chainescore."12:$Rescue1{'FYWHCDN'} "; $d_local++;}
                if($Rescue1{'FYWHC'} != 0){$chainescore = $chainescore."13:$Rescue1{'FYWHC'} "; $d_local++;}
                if($Rescue1{'DN'} != 0){$chainescore = $chainescore."14:$Rescue1{'DN'} "; $d_local++;}
                if($Rescue1{'EQM'} != 0){$chainescore = $chainescore."15:$Rescue1{'EQM'} "; $d_local++;}
                if($Rescue1{'EQ'} != 0){$chainescore = $chainescore."16:$Rescue1{'EQ'} "; $d_local++;}
                if($Rescue1{'M'} != 0){$chainescore = $chainescore."17:$Rescue1{'M'} "; $d_local++;}
                if($Rescue1{'S'} != 0){$chainescore = $chainescore."18:$Rescue1{'S'} "; $d_local++;}
          }



         #RESCUE1N
         $Rescue1N{'IV'} = 0;
         $Rescue1N{'A'} = 0;
         $Rescue1N{'G'} = 0;
         $Rescue1N{'P'} = 0;
         $Rescue1N{'T'} = 0;
         $Rescue1N{'LKREQM'} = 0;
         $Rescue1N{'FYWHDNC'} = 0;
         $Rescue1N{'S'} = 0;

         if($Tab->{"R1N $i"} ne 'Not available'){
                # LEARN FILE RESCUE R1N
                 $ligne_outR1N = $Tab->{"R1N $i"};
                 @item = split("\\(",$ligne_outR1N);
                 $res = $item[0];
                 chop($res);
                 @item2 = split("\\)",$item[1]);
                 $Rescue1N{$res} = $item2[0];
                 #$Rescue1N{$res}= sprintf ("%.2f",$item2[0]);

                if($Rescue1N{'IV'} != 0){$chainescore = $chainescore."19:$Rescue1N{'IV'} ";$d_local++;}
                if($Rescue1N{'A'} != 0){$chainescore = $chainescore."20:$Rescue1N{'A'} "; $d_local++;}
                if($Rescue1N{'G'} != 0){$chainescore = $chainescore."21:$Rescue1N{'G'} "; $d_local++;}
                if($Rescue1N{'P'} != 0){$chainescore = $chainescore."22:$Rescue1N{'P'} "; $d_local++;}
                if($Rescue1N{'T'} != 0){$chainescore = $chainescore."23:$Rescue1N{'T'} "; $d_local++;}
                if($Rescue1N{'LKREQM'} != 0){$chainescore = $chainescore."24:$Rescue1N{'LKREQM'} "; $d_local++;}
                if($Rescue1N{'FYWHDNC'} != 0){$chainescore = $chainescore."25:$Rescue1N{'FYWHDNC'} "; $d_local++;}
                if($Rescue1N{'S'} != 0){$chainescore = $chainescore."26:$Rescue1N{'S'} ";  $d_local++;}
         }


         # RESCUE 2
         $Rescue2{'A'} = 0;
         $Rescue2{'C'} = 0;
         $Rescue2{'D'} = 0;
         $Rescue2{'E'} = 0;
         $Rescue2{'F'} = 0;
         $Rescue2{'G'} = 0;
         $Rescue2{'H'} = 0;
         $Rescue2{'I'} = 0;
         $Rescue2{'K'} = 0;
         $Rescue2{'L'} = 0;
         $Rescue2{'M'} = 0;
         $Rescue2{'N'} = 0;
         $Rescue2{'P'} = 0;
         $Rescue2{'Q'} = 0;
         $Rescue2{'R'} = 0;
         $Rescue2{'S'} = 0;
         $Rescue2{'T'} = 0;
         $Rescue2{'V'} = 0;
         $Rescue2{'W'} = 0;
         $Rescue2{'Y'} = 0;


          if($Tab->{"R2 $i"} ne 'Not available'){
                 #LEARN FILE RESCUE 2
                 $ligne_outR2 = $Tab->{"R2 $i"};
                 @item3 = split ("\\) ",$ligne_outR2);
                 $nbcol = @item3;
                 for ($j =0;$j<3;$j++) {
                   if($j < $nbcol){
                      @rsc = split(" \\(",$item3[$j]);
                      if ($j==0) {$r= substr($rsc[0],1);} else {$r=$rsc[0];}
                      if($j == 0){$Rescue2{"$r"} = $rsc[1]*100;} #1ere place
                      if($j == 1){$Rescue2{"$r"} = $rsc[1]*10;} #2eme place
                      if($j == 2){$Rescue2{"$r"} = $rsc[1];} #3eme place
                      #$Rescue2{"$r"} = sprintf("%.2f",$rr);
                   }
                 }
                 if($Rescue2{'A'} != 0){$chainescore = $chainescore."27:$Rescue2{'A'} ";  $d_local++;}
                 if($Rescue2{'C'} != 0){$chainescore = $chainescore."28:$Rescue2{'C'} "; $d_local++;}
                 if($Rescue2{'D'} != 0){$chainescore = $chainescore."29:$Rescue2{'D'} "; $d_local++;}
                 if($Rescue2{'E'} != 0){$chainescore = $chainescore."30:$Rescue2{'E'} "; $d_local++;}
                 if($Rescue2{'F'} != 0){$chainescore = $chainescore."31:$Rescue2{'F'} "; $d_local++;}
                 if($Rescue2{'G'} != 0){$chainescore = $chainescore."32:$Rescue2{'G'} "; $d_local++;}
                 if($Rescue2{'H'} != 0){$chainescore = $chainescore."33:$Rescue2{'H'} "; $d_local++;}
                 if($Rescue2{'I'} != 0){$chainescore = $chainescore."34:$Rescue2{'I'} "; $d_local++;}
                 if($Rescue2{'K'} != 0){$chainescore = $chainescore."35:$Rescue2{'K'} "; $d_local++;}
                 if($Rescue2{'L'} != 0){$chainescore = $chainescore."36:$Rescue2{'L'} "; $d_local++;}
                 if($Rescue2{'M'} != 0){$chainescore = $chainescore."37:$Rescue2{'M'} "; $d_local++;}
                 if($Rescue2{'N'} != 0){$chainescore = $chainescore."38:$Rescue2{'N'} "; $d_local++;}
                 if($Rescue2{'P'} != 0){$chainescore = $chainescore."39:$Rescue2{'P'} "; $d_local++;}
                 if($Rescue2{'Q'} != 0){$chainescore = $chainescore."40:$Rescue2{'Q'} "; $d_local++;}
                 if($Rescue2{'R'} != 0){$chainescore = $chainescore."41:$Rescue2{'R'} "; $d_local++;}
                 if($Rescue2{'S'} != 0){$chainescore = $chainescore."42:$Rescue2{'S'} "; $d_local++;}
                 if($Rescue2{'T'} != 0){$chainescore = $chainescore."43:$Rescue2{'T'} "; $d_local++;}
                 if($Rescue2{'V'} != 0){$chainescore = $chainescore."44:$Rescue2{'V'} "; $d_local++;}
                 if($Rescue2{'W'} != 0){$chainescore = $chainescore."45:$Rescue2{'W'} "; $d_local++;}
                 if($Rescue2{'Y'} != 0){$chainescore = $chainescore."46:$Rescue2{'Y'} "; $d_local++;}
         }





         #PLATON
         $Platon{'A'} = 0;
         $Platon{'C'} = 0;
         $Platon{'D'} = 0;
         $Platon{'E'} = 0;
         $Platon{'F'} = 0;
         $Platon{'G'} = 0;
         $Platon{'H'} = 0;
         $Platon{'I'} = 0;
         $Platon{'K'} = 0;
         $Platon{'L'} = 0;
         $Platon{'M'} = 0;
         $Platon{'N'} = 0;
         $Platon{'P'} = 0;
         $Platon{'Q'} = 0;
         $Platon{'R'} = 0;
         $Platon{'S'} = 0;
         $Platon{'T'} = 0;
         $Platon{'V'} = 0;
         $Platon{'W'} = 0;
         $Platon{'Y'} = 0;



         if($Tab->{"PLATON $i"} ne 'Not available'){

                 #LEARN FILE PLATON
                 $ligne_outPL = $Tab->{"PLATON $i"};
                 @item4P = split ("\\) ",$ligne_outPL);
                 $nbcolP = @item4P;
                 for ($h=0;$h<3;$h++){
                   if($h<$nbcolP){
                      @resPL = split (" \\(",$item4P[$h]);
                      $rPL = $code{$resPL[0]};
                      if($h == 0){$Platon{"$rPL"} = $resPL[1]*10;}
                      if($h == 1){$Platon{"$rPL"} = $resPL[1];}
                      if($h == 2){
                         $s7 =$resPL[1];
                        $Platon{"$rPL"} =$s7/10;
                      }
                      #$Platon{"$rPL"}= sprintf ("%.2f",$resPL[1]);
                   }
               }
               if($Platon{'A'} != 0){$chainescore = $chainescore."47:$Platon{'A'} "; $d_local++;}
               if($Platon{'C'} != 0){$chainescore = $chainescore."48:$Platon{'C'} "; $d_local++;}
               if($Platon{'D'} != 0){$chainescore = $chainescore."49:$Platon{'D'} "; $d_local++;}
               if($Platon{'E'} != 0){$chainescore = $chainescore."50:$Platon{'E'} "; $d_local++;}
               if($Platon{'F'} != 0){$chainescore = $chainescore."51:$Platon{'F'} "; $d_local++;}
               if($Platon{'G'} != 0){$chainescore = $chainescore."52:$Platon{'G'} "; $d_local++;}
               if($Platon{'H'} != 0){$chainescore = $chainescore."53:$Platon{'H'} "; $d_local++;}
               if($Platon{'I'} != 0){$chainescore = $chainescore."54:$Platon{'I'} "; $d_local++;}
               if($Platon{'K'} != 0){$chainescore = $chainescore."55:$Platon{'K'} "; $d_local++;}
               if($Platon{'L'} != 0){$chainescore = $chainescore."56:$Platon{'L'} "; $d_local++;}
               if($Platon{'M'} != 0){$chainescore = $chainescore."57:$Platon{'M'} "; $d_local++;}
               if($Platon{'N'} != 0){$chainescore = $chainescore."58:$Platon{'N'} "; $d_local++;}
               if($Platon{'P'} != 0){$chainescore = $chainescore."59:$Platon{'P'} "; $d_local++;}
               if($Platon{'Q'} != 0){$chainescore = $chainescore."60:$Platon{'Q'} "; $d_local++;}
               if($Platon{'R'} != 0){$chainescore = $chainescore."61:$Platon{'R'} "; $d_local++;}
               if($Platon{'S'} != 0){$chainescore = $chainescore."62:$Platon{'S'} "; $d_local++;}
               if($Platon{'T'} != 0){$chainescore = $chainescore."63:$Platon{'T'} "; $d_local++;}
               if($Platon{'V'} != 0){$chainescore = $chainescore."64:$Platon{'V'} "; $d_local++;}
               if($Platon{'W'} != 0){$chainescore = $chainescore."65:$Platon{'W'} "; $d_local++;}
               if($Platon{'Y'} != 0){$chainescore = $chainescore."66:$Platon{'Y'} "; $d_local++;}
         }


         # SVM
         $svm{'A'} = 0;
         $svm{'C'} = 0;
         $svm{'D'} = 0;
         $svm{'E'} = 0;
         $svm{'F'} = 0;
         $svm{'G'} = 0;
         $svm{'H'} = 0;
         $svm{'I'} = 0;
         $svm{'K'} = 0;
         $svm{'L'} = 0;
         $svm{'M'} = 0;
         $svm{'N'} = 0;
         $svm{'P'} = 0;
         $svm{'Q'} = 0;
         $svm{'R'} = 0;
         $svm{'S'} = 0;
         $svm{'T'} = 0;
         $svm{'V'} = 0;
         $svm{'W'} = 0;
         $svm{'Y'} = 0;


         if($Tab->{"SVM $i"} ne 'Not available'){
               # LEARN FILE SVM
               $ligne_outSVM = $Tab->{"SVM $i"};
               @itemSVM = split("\\) ",$ligne_outSVM);
               $nbcolS = @itemSVM;
               for ($d=0;$d<3;$d++) {
                 if($d<$nbcolS){
                   @r1 = split(" \\(",$itemSVM[$d]);
                   if ($d == 0) {$SVMr = substr($r1[0],1);} else { $SVMr = $r1[0];}
                     if($r1[1] > 0){
                        if($d==0){$svm{"$SVMr"} = $r1[1]*10;}
                        if($d==0){$svm{"$SVMr"} = $r1[1];}
                        if($d==0){
                        $s8 = $r1[1];
                        $svm{"$SVMr"} =$s8/10;}
                        #$SVMs = sprintf ("%.2f",$SVMst);
                        #$svm{"$SVMr"} = $SVMs;
                     }
                 }
               }
               if($svm{'A'} != 0){ $chainescore = $chainescore."67:$svm{'A'} "; $d_local++;}
               if($svm{'C'} != 0){ $chainescore = $chainescore."68:$svm{'C'} "; $d_local++;}
               if($svm{'D'} != 0){ $chainescore = $chainescore."69:$svm{'D'} "; $d_local++;}
               if($svm{'E'} != 0){ $chainescore = $chainescore."70:$svm{'E'} "; $d_local++;}
               if($svm{'F'} != 0){ $chainescore = $chainescore."71:$svm{'F'} "; $d_local++;}
               if($svm{'G'} != 0){ $chainescore = $chainescore."72:$svm{'G'} "; $d_local++;}
               if($svm{'H'} != 0){ $chainescore = $chainescore."73:$svm{'H'} "; $d_local++;}
               if($svm{'I'} != 0){ $chainescore = $chainescore."74:$svm{'I'} "; $d_local++;}
               if($svm{'K'} != 0){ $chainescore = $chainescore."75:$svm{'K'} "; $d_local++;}
               if($svm{'L'} != 0){ $chainescore = $chainescore."76:$svm{'L'} "; $d_local++;}
               if($svm{'M'} != 0){ $chainescore = $chainescore."77:$svm{'M'} "; $d_local++;}
               if($svm{'N'} != 0){ $chainescore = $chainescore."78:$svm{'N'} "; $d_local++;}
               if($svm{'P'} != 0){ $chainescore = $chainescore."79:$svm{'P'} "; $d_local++;}
               if($svm{'Q'} != 0){ $chainescore = $chainescore."80:$svm{'Q'} "; $d_local++;}
               if($svm{'R'} != 0){ $chainescore = $chainescore."81:$svm{'R'} "; $d_local++;}
               if($svm{'S'} != 0){ $chainescore = $chainescore."82:$svm{'S'} "; $d_local++;}
               if($svm{'T'} != 0){ $chainescore = $chainescore."83:$svm{'T'} "; $d_local++;}
               if($svm{'V'} != 0){ $chainescore = $chainescore."84:$svm{'V'} "; $d_local++;}
               if($svm{'W'} != 0){ $chainescore = $chainescore."85:$svm{'W'} "; $d_local++;}
               if($svm{'Y'} != 0){ $chainescore = $chainescore."86:$svm{'Y'} "; $d_local++;}
           }

          if ($chainescore eq ""){ $chainescore = "Not available"; }
          #APP
          foreach $name_res (@code) {  # pour tous les noms de fichier
                $file_name = "TRAIN_".$name_res;
                open(OUT,">> $CRAACKDIR/VOTE/CONSENSUS_MySVM_19/TRAINFILE/".$file_name);
                if($Tab->{$i} eq $name_res){ print OUT "$chainescore +1\n";}
                else { print OUT "$chainescore -1\n";}
                close(OUT);
          }

      } #end for
 }




 sub AA2R1{

    my ($aa)= @_;

        $R1{"G"} = "G";
        $R1{"A"} = "A";
        $R1{"V"} = "V";
        $R1{"F"} = "FYWHC";
        $R1{"I"} = "I";
        $R1{"L"} = "L";
        $R1{"M"} = "M";
        $R1{"D"} = "DN";
        $R1{"E"} = "EQ";
        $R1{"Q"} = "EQ";
        $R1{"K"} = "K";
        $R1{"R"} = "R";
        $R1{"S"} = "S";
        $R1{"T"} = "T";
        $R1{"Y"} = "FYWHC";
        $R1{"H"} = "FYWHC";
        $R1{"C"} = "FYWHC";
        $R1{"N"} = "DN";
        $R1{"W"} = "FYWHC";
        $gr1 = $R1{$aa};

    return $gr1;
 }

 sub AA2SVMC{

    my ($aa)= @_;

        $SVMC{"G"} = "G";
        $SVMC{"A"} = "A";
        $SVMC{"V"} = "VI";
        $SVMC{"F"} = "FYHCWDN";
        $SVMC{"I"} = "VI";
        $SVMC{"L"} = "EQMKRL";
        $SVMC{"M"} = "EQMKRL";
        $SVMC{"D"} = "FYHCWDN";
        $SVMC{"E"} = "EQMKRL";
        $SVMC{"Q"} = "EQMKRL";
        $SVMC{"K"} = "EQMKRL";
        $SVMC{"R"} = "EQMKRL";
        $SVMC{"S"} = "S";
        $SVMC{"T"} = "T";
        $SVMC{"Y"} = "FYHCWDN";
        $SVMC{"H"} = "FYHCWDN";
        $SVMC{"C"} = "FYHCWDN";
        $SVMC{"N"} = "FYHCWDN";
        $SVMC{"W"} = "FYHCWDN";
        $gr1 = $SVMC{$aa};

    return $gr1;
 }


 # creation d'une fonction qui traduit le resultat en groupage compatible avec RESCUE1N

 sub AA2R1N {

   my ($aa)=@_;

    $R1N{"G"} = "G";
    $R1N{"A"} = "A";
    $R1N{"V"} = "IV";
    $R1N{"F"} = "FYWHDNC";
    $R1N{"I"} = "IV";
    $R1N{"L"} = "LKREQM";
    $R1N{"M"} = "LKREQM";
    $R1N{"D"} = "FYWHDNC";
    $R1N{"E"} = "LKREQM";
    $R1N{"Q"} = "LKREQM";
    $R1N{"K"} = "LKREQM";
    $R1N{"R"} = "LKREQM";
    $R1N{"S"} = "S";
    $R1N{"T"} = "T";
    $R1N{"Y"} = "FYWHDNC";
    $R1N{"H"} = "FYWHDNC";
    $R1N{"C"} = "FYWHDNC";
    $R1N{"N"} = "FYWHDNC";
    $R1N{"W"} = "FYWHDNC";

   $gr1N = $R1N{$aa};

    return $gr1N;

 }


sub make_plot {

    my ($soft,$eff,$res_find) = @_;

    if(($soft ne "RESCUE1") && ($soft ne "RESCUE1N")  && ($soft ne "SVM_CONCENSUS")){
        $cptres{"G"} = 0;
        $cptres{"A"} = 0;
        $cptres{"V"} = 0;
        $cptres{"F"} = 0;
        $cptres{"I"} = 0;
        $cptres{"L"} = 0;
        $cptres{"M"} = 0;
        $cptres{"D"} = 0;
        $cptres{"E"} = 0;
        $cptres{"Q"} = 0;
        $cptres{"K"} = 0;
        $cptres{"R"} = 0;
        $cptres{"S"} = 0;
        $cptres{"T"} = 0;
        $cptres{"Y"} = 0;
        $cptres{"H"} = 0;
        $cptres{"C"} = 0;
        $cptres{"N"} = 0;
        $cptres{"W"} = 0;
        @codes = keys(%cptres);

        open (OUT,'> ./'.$soft.'.plt');

        print OUT "\$ DATA=GRID4D\n";
        print OUT "\% axisscale=f\n";
        print OUT "\% meshplot\n";
        print OUT "\% NX=21 XMIN=0 XMAX=20 \n";
        print OUT "\% NY=21 YMIN=0 YMAX=20 \n";
        print OUT "\% NZ=2 ZMIN=0 ZMAX=0.5 \n";
        print OUT "\% toplabel =  \"Sortie ",$soft,"\n";
        print OUT "\% subtitle =  \"Efficacite Totale: ",$eff,"\n";
        print OUT "\% xlabel = \" Residus Trouves \"\n";
        print OUT "\% ylabel = \" Residus Cibles \"\n\n";

        $j = 0;
        foreach $name_res (@codes) {  $j++; print OUT "\% yticklabel = \($j \"$name_res\"\)\n"; }
        print OUT "\n";
        $j = 0;
        foreach $name_res (@codes) {  $j++; print OUT "\% xticklabel = \($j \"$name_res\"\)\n"; }
        print OUT "\n";
        for($i = 0; $i<21; $i++){ print OUT "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n"; }
        print OUT "\n";
        print OUT " 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n";

        foreach $name_res (@codes) {
                print OUT "\n";
                print OUT " 0 ";
                foreach $res_f (@codes) {

                        if($res_find->{"$name_res"} != 0){
                        	$rf = $res_find->{"$name_res $res_f"};
                                $nbcalc = ( $rf/$res_find->{"$name_res"} ) * 100;
                        }else {  $nbcalc = 0; }
                        $nom = $res_f;
                        print OUT " ",$nbcalc," ";
                        #print "res_cible : ",$name_res," res_trouve",$nom," somme : ",$nbcalc,"\n";


                }
                print OUT " 0 \n";
        }
        print OUT " 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n";
        print OUT "\n";
        print OUT "\$ END\n";
        close OUT;
       # $result = system("/PROG/LINUX/prog/plotmtv-1.4.1/Bin/plotmtv -noxplot -o ./$soft.ps ./$soft.plt");
       }
       elsif($soft eq "RESCUE1"){
        $cptresR1{"FYWHC"} = 0;
        $cptresR1{"A"} = 0;
        $cptresR1{"V"} = 0;
        $cptresR1{"DN"} = 0;
        $cptresR1{"I"} = 0;
        $cptresR1{"L"} = 0;
        $cptresR1{"EQ"} = 0;
        $cptresR1{"M"} = 0;
        $cptresR1{"G"} = 0;
        $cptresR1{"R"} = 0;
        $cptresR1{"K"} = 0;
        $cptresR1{"S"} = 0;
        $cptresR1{"T"} = 0;
        @codes = keys(%cptresR1);

        open (OUT,'> ./'.$soft.'.plt');

        print OUT "\$ DATA=GRID4D\n";
        print OUT "\% axisscale=f\n";
        print OUT "\% meshplot\n";
        print OUT "\% NX=15 XMIN=0 XMAX=14 \n";
        print OUT "\% NY=15 YMIN=0 YMAX=14 \n";
        print OUT "\% NZ=2 ZMIN=0 ZMAX=0.5 \n";
        print OUT "\% toplabel =  \"Sortie ",$soft,"\n";
        print OUT "\% subtitle =  \"Efficacite Totale: ",$eff,"\n";
        print OUT "\% xlabel = \" Residus Trouves \"\n";
        print OUT "\% ylabel = \" Residus Cibles \"\n\n";

        $j = 0;
        foreach $name_res (@codes) {  $j++; print OUT "\% yticklabel = \($j \"$name_res\"\)\n"; }
        print OUT "\n";
        $j = 0;
        foreach $name_res (@codes) {  $j++; print OUT "\% xticklabel = \($j \"$name_res\"\)\n"; }
        print OUT "\n";
        for($i = 0; $i<15; $i++){ print OUT "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n"; }
        print OUT "\n";
        print OUT " 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n";
        #print $res_find->{"G G"};
        #print $res_find->{"G"}." \n";
        foreach $name_res (@codes) {
                print OUT "\n";
                print OUT " 0 ";
                foreach $res_f (@codes) {

                        if($res_find->{"$name_res"} != 0){
                        	$rf = $res_find->{"$name_res $res_f"};
                                $nbcalc = ( $rf/$res_find->{"$name_res"} ) * 100;
                        }else {  $nbcalc = 0; }
                        $nom = $res_f;
                        print OUT " ",$nbcalc," ";
                        #print "res_cible : ",$name_res," res_trouve ",$nom," somme : ",$rf,"\n";


                }  print "\n";
                print OUT " 0 \n";
        }
        print OUT " 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n";
        print OUT "\n";
        print OUT "\$ END\n";
        close OUT;
        #$result = system("/PROG/LINUX/prog/plotmtv-1.4.1/Bin/plotmtv -noxplot -o ./$soft.ps ./$soft.plt");
       }


       elsif($soft eq "RESCUE1N"){
        $cptresR1N{"IV"} = 0;
        $cptresR1N{"A"} = 0;
        $cptresR1N{"G"} = 0;
        $cptresR1N{"T"} = 0;
        $cptresR1N{"LKREQM"} = 0;
        $cptresR1N{"FYWHDNC"} = 0;
        $cptresR1N{"S"} = 0;
        @codes = keys(%cptresR1N);

        open (OUT,'> ./'.$soft.'.plt');

        print OUT "\$ DATA=GRID4D\n";
        print OUT "\% axisscale=f\n";
        print OUT "\% meshplot\n";
        print OUT "\% NX=9 XMIN=0 XMAX=8 \n";
        print OUT "\% NY=9 YMIN=0 YMAX=8 \n";
        print OUT "\% NZ=2 ZMIN=0 ZMAX=0.5 \n";
        print OUT "\% toplabel =  \"Sortie ",$soft,"\n";
        print OUT "\% subtitle =  \"Efficacite Totale: ",$eff,"\n";
        print OUT "\% xlabel = \" Residus Trouves \"\n";
        print OUT "\% ylabel = \" Residus Cibles \"\n\n";

        $j = 0;
        foreach $name_res (@codes) {  $j++; print OUT "\% yticklabel = \($j \"$name_res\"\)\n"; }
        print OUT "\n";
        $j = 0;
        foreach $name_res (@codes) {  $j++; print OUT "\% xticklabel = \($j \"$name_res\"\)\n"; }
        print OUT "\n";
        for($i = 0; $i<9; $i++){ print OUT "0 0 0 0 0 0 0 0 0 \n"; }
        print OUT "\n";
        print OUT " 0 0 0 0 0 0 0 0 0 \n";

        foreach $name_res (@codes) {
                print OUT "\n";
                print OUT " 0 ";
                foreach $res_f (@codes) {

                        if($res_find->{"$name_res"} != 0){
                        	$rf = $res_find->{"$name_res $res_f"};
                                $nbcalc = ( $rf/$res_find->{"$name_res"} ) * 100;
                        }else {  $nbcalc = 0; }
                        $nom = $res_f;
                        print OUT " ",$nbcalc," ";
                        #print "res_cible : ",$name_res," res_trouve",$nom," somme : ",$nbcalc,"\n";


                }
                print OUT " 0 \n";
        }
        print OUT " 0 0 0 0 0 0 0 0 0 \n";
        print OUT "\n";
        print OUT "\$ END\n";
        close OUT;
        #$result = system("/PROG/LINUX/prog/plotmtv-1.4.1/Bin/plotmtv -noxplot -o ./$soft.ps ./$soft.plt");
       }

       elsif($soft eq "SVM_CONCENSUS"){
        $cptresSVM{"VI"} = 0;
        $cptresSVM{"A"} = 0;
        $cptresSVM{"G"} = 0;
        $cptresSVM{"T"} = 0;
        $cptresSVM{"EQMKRL"} = 0;
        $cptresSVM{"FYHCWDN"} = 0;
        $cptresSVM{"S"} = 0;
        @codes = keys(%cptresSVM);

        open (OUT,'> ./'.$soft.'.plt');

        print OUT "\$ DATA=GRID4D\n";
        print OUT "\% axisscale=f\n";
        print OUT "\% meshplot\n";
        print OUT "\% NX=9 XMIN=0 XMAX=8 \n";
        print OUT "\% NY=9 YMIN=0 YMAX=8 \n";
        print OUT "\% NZ=2 ZMIN=0 ZMAX=0.5 \n";
        print OUT "\% toplabel =  \"Sortie ",$soft,"\n";
        print OUT "\% subtitle =  \"Efficacite Totale: ",$eff,"\n";
        print OUT "\% xlabel = \" Residus Trouves \"\n";
        print OUT "\% ylabel = \" Residus Cibles \"\n\n";

        $j = 0;
        foreach $name_res (@codes) {  $j++; print OUT "\% yticklabel = \($j \"$name_res\"\)\n"; }
        print OUT "\n";
        $j = 0;
        foreach $name_res (@codes) {  $j++; print OUT "\% xticklabel = \($j \"$name_res\"\)\n"; }
        print OUT "\n";
        for($i = 0; $i<9; $i++){ print OUT "0 0 0 0 0 0 0 0 0 \n"; }
        print OUT "\n";
        print OUT " 0 0 0 0 0 0 0 0 0 \n";

        foreach $name_res (@codes) {
                print OUT "\n";
                print OUT " 0 ";
                foreach $res_f (@codes) {

                        if($res_find->{"$name_res"} != 0){
                                $rf = $res_find->{"$name_res $res_f"};
                                $nbcalc = ( $rf/$res_find->{"$name_res"} ) * 100;
                        }else {  $nbcalc = 0; }
                        $nom = $res_f;
                        print OUT " ",$nbcalc," ";
                        #print "res_cible : ",$name_res," res_trouve",$nom," somme : ",$nbcalc,"\n";


                }
                print OUT " 0 \n";
        }
        print OUT " 0 0 0 0 0 0 0 0 0 \n";
        print OUT "\n";
        print OUT "\$ END\n";
        close OUT;
        #$result = system("/PROG/LINUX/prog/plotmtv-1.4.1/Bin/plotmtv -noxplot -o ./$soft.ps ./$soft.plt");
       }


 }# end sub make_plot


 #definition de la fonction VOTE

 sub vote {

$code{"GLY"} = "G";
$code{"ALA"} = "A";
$code{"VAL"} = "V";
$code{"PHE"} = "F";
$code{"ILE"} = "I";
$code{"LEU"} = "L";
$code{"PRO"} = "P";
$code{"MET"} = "M";
$code{"ASP"} = "D";
$code{"GLU"} = "E";
$code{"GLN"} = "Q";
$code{"LYS"} = "K";
$code{"ARG"} = "R";
$code{"SER"} = "S";
$code{"THR"} = "T";
$code{"TYR"} = "Y";
$code{"HIS"} = "H";
$code{"CYS"} = "C";
$code{"ASN"} = "N";
$code{"TRP"} = "W";
@code = keys(%code);

     my ($valR1,$valR1N,$valR2,$valP,$valSVM,$valConsSVM)=@_;

      foreach $j (@code){
		 	$vote{$code{$j}} = 0;
		 }



       #RESCUE1
      if($valR1 ne 'Not available'){
         	$_ =  $valR1;
         	# ON RECUPERE L'ACIDE AMINE
         	if (/->/){
        	  @itemR1 = split("-> ",$valR1);
         	  @item1R1 = split(" \\(",$itemR1[1]);
         	  $res = $item1R1[0];
         	  @item2R1 = split("\\)",$item1R1[1]);
         	  $s1 =$item2R1[0];
         	  @taa1 = split(//,$res);
         	  $nb1 = @taa1;
                        for ($t=0;$t<$nb1;$t++){
                                 if (($taa1[$t] ne " ") && ($s1 == 0)) {
              	
                                    $vote{"$taa1[$t]"} = $vote{"$taa1[$t]"}+0.8;

                                   }
                                   if (($taa1[$t] ne " ") && ($s1 > 0) && ($s1 <= 90)) {
                                   $vote{"$taa1[$t]"} = $vote{"$taa1[$t]"}+1;	
                                   }
                                   if (($taa1[$t] ne " ") && ($s1 > 90)) {
                                   $vote{"$taa1[$t]"} = $vote{"$taa1[$t]"}+1.2;
                                   }

                 		
                 	}
         	
         	 }

         	else {
         	  @item3R1 = split(" \\(",$valR1);
         	  $rr1 = $item3R1[0];
            	  $res = substr($rr1,1);
            	  #print "---$res---$rr1---";
            	  @item4R1 = split("\\)",$item3R1[1]);
         	  $s3=$item4R1[0];
         	  if (($res ne " ") && ($s3 == 0)){
         	  $vote{"$res"} = $vote{"$res"}+0.8;
         	  }
         	  if (($res ne " ") && ($s3 > 0 ) && ($s3 <= 90)) {
         	  $vote{"$res"} = $vote{"$res"}+1;
         	  }
         	  if (($res ne " ") && ($s3 > 90)) {
         	  $vote{"$res"} = $vote{"$res"}+1.2;
         	  }
		}

           }
        #RESCUE1N

          if($valR1N ne 'Not available'){
                 $_=$valR1N;
                 @item = split("\\(",$valR1N);
                 $res = $item[0];
                 chop($res);
                 @item2 = split("\\)",$item[1]);
                 $s4 = $item2[0];
                 @taa1N = split(//,$res);
                 $nb1N = @taa1N;
                 for ($s=0;$s<$nb1N;$s++){
                                 if (($taa1N[$s] ne " ") && ($s4 > 60))  {
              	
                                    $vote{"$taa1N[$s]"} = $vote{"$taa1N[$s]"}+1.2;

                                   }

                                 if (($taa1N[$s] ne " ") && ($s4 <=60) && ($s4 >=35)) {
                                    $vote{"$taa1N[$s]"} = $vote{"$taa1N[$s]"}+1;
                                   }
                                 if (($taa1N[$s] ne " ") && ($s4 < 35 )) {
                                   $vote{"$taa1N[$s]"} = $vote{"$taa1N[$s]"}+0.8;
                                  } 	
                 		
                 	}
                  }

       #RESCUE2
          if($valR2 ne 'Not available'){
                 #LEARN FILE RESCUE 2
                 $_= $valR2;
                 @item3 = split ("\\) ",$valR2);
                 $nbcol = @item3;

                 for ($j =0;$j<3;$j++) {
	           if($j < $nbcol){
                      @rsc = split(" \\(",$item3[$j]);
                      if ($j==0){$r= substr($rsc[0],1);
                      		#print "---$r---$rsc[1]---";
                      }
                      if (($j==0) && ($r ne " " ) && ($rsc[1] >= 0.6 )) {
                          #$r= substr($rsc[0],1);
                          #print "---$r---$rsc[1]---";
                          $vote{"$r"}= $vote{"$r"}+1.2;
                      }
                       if (($j==0) && ($r ne " " ) && ($rsc[1] < 0.6 ) && ($rsc[1]>=0.35)) {
                          #$r= substr($rsc[0],1);
                          $vote{"$r"}= $vote{"$r"}+1;
                      }

                      if (($j==0) && ($r ne " " ) && ($rsc[1] < 0.35 )) {
                          #$r= substr($rsc[0],1);
                          $vote{"$r"}= $vote{"$r"}+0.8;
                      }
                      if (($j==1) && ($rsc[0] ne " " )) {
                          $r=$rsc[0];
                          $vote{"$r"}= $vote{"$r"}+0.5;
                      }
                     if (($j==2) && ($rsc[0] ne " " )){
                         $r = $rsc[0];
                         $vote{"$r"}= $vote{"$r"}+0.25;
                      }

		    }
                  }

               }
         #Platon
             if($valP ne 'Not available'){
                 $_ = $valP;
                 @item4P = split ("\\) ",$valP);
                 $nbcolP = @item4P;
                 for ($h=0;$h<3;$h++){
		   if($h<$nbcolP-1){
                        @resPL = split (" \\(",$item4P[$h]);
                        if  (($h==0) && ($resPL[0] ne " ") )  {
                        	   $rPL = $code{$resPL[0]};
                                   $vote{"$rPL"} = $vote{"$rPL"}+0.8;
                            }
                         if (($h==1) && ($resPL[0] ne " ")) {
                                      $rPL = $code{$resPL[0]};
                                      $vote{"$rPL"} = $vote{"$rPL"}+0.4;
                            }
                         if (($h==2) && ($resPL[0] ne " ")) {
                                      $rPL = $code{$resPL[0]};
                                      $vote{"$rPL"} = $vote{"$rPL"}+0.2;
                            }
	  	   }	
                }

             }
         #SVM

         if($valSVM ne 'Not available'){
              $vv = $valSVM;
              $valSVM =  substr($vv,1);
              $_ = $valSVM;
              @itemSVM = split("\\) ",$valSVM);
               $nbcolS = @itemSVM;#print "SVM:---$vv---$valSVM---$nbcolS---\n";
               for ($d=0;$d<3;$d++) {
		 if($d<$nbcolS){
                   @r1 = split(" \\(",$itemSVM[$d]);
                   #if (($d == 0)&& ($r1[0] ne " ") && ($r1[1] > 0))  {
                   if (($d == 0) && ($r1[0] ne " ")) {
                   	#$SVMr = substr($r1[0],1);
                   	$SVMr = $r1[0];
                        $vote{"$SVMr"} = $vote{"$SVMr"}+1.2;
                        }
                     if (($d == 1) && ($r1[0] ne " ")) {
                        $SVMr = $r1[0];
                        $vote{"$SVMr"} = $vote{"$SVMr"}+0.5;
                      }

                   if (($d == 2) && ($r1[0] ne " ")) {
                        $SVMr = $r1[0];
                        $vote{"$SVMr"} = $vote{"$SVMr"}+0.25;
                      }
	           }	
		 }
               }


            # CONSENSUS SVM
                if($valConsSVM ne 'No result'){
                   $CONSsvm = $valConsSVM;
                   $valConsSVM =  substr($CONSsvm,1);
                   $_ = $valConsSVM;
                   #print "-----$valConsSVM------";
                   @itemConsSVM = split(" \\(",$valConsSVM);
                   $resConsSVM = $itemConsSVM[0];
                   @item2ConsSVM = split("\\)",$itemConsSVM[1]);
                   $s6 = $item2ConsSVM[0];
                   @taaCSVM = split(//,$resConsSVM);
                   $nbCSVM = @taaCSVM ;
                            for ($f=0;$f<$nbCSVM;$f++){
                                       if (( $taaCSVM[$f] ne " ") && ($s6 >= 1))  {
                                           $vote{"$taaCSVM[$f]"} = $vote{"$taaCSVM[$f]"}+1.2;
                                       }
                                       if (($taaCSVM[$f] ne " ") && ($s6 < 1) && ($s6 >=0.5)) {
                                           $vote{"$taaCSVM[$f]"} = $vote{"$taaCSVM[$f]"}+1;
                                       }
                 	     }
                  }



          # classement par ordre croissant  et recuperation des trois premiers

              @vote_ordre = sort {$vote{$b} <=> $vote{$a}} keys %vote;
              $nbc = @vote_ordre;
              $chaine = "";
	      $reponse = "NO";
		
	      #if(1 == 0){
              #  $aa1 = "-";
              #  $aa2 = "-";
              #  $aa3 = "-";
              #  $sc1 = "-";
              #  $sc2 = "-";
              #  $sc3 = "-";
#
#                $aa1 = $vote_ordre[0];
#                $aa2 = $vote_ordre[1];
#                $aa3 = $vote_ordre[2];
#                $sc1 = $vote{$aa1};
#                $sc2 = $vote{$aa2};
#                $sc3 = $vote{$aa3};
#		if ($sc1 == 0) {$reponse = "YES";}

# format constant

#                $chaine ="$aa1 ($sc1) ";
#		if ($sc2 != 0) { $chaine = $chaine."- $aa2 ($sc2) "};
#		if ($sc3 != 0) { $chaine = $chaine."- $aa3 ($sc3) "};
#	      }
#	      if(1 == 1){
		for($d=0;$d<=$nbc;$d++){
			$aa1 = $vote_ordre[$d];	
			$sc1 = $vote{$aa1};
			if ($sc1 != 0) { $chaine =  $chaine."$aa1 ($sc1); ";}
			$reponse = "YES";
		}
#	      }
##            	
# ou association des equivalent:

 #          if ($sc1 == $sc2) {
 #              $aa =$aa1.$aa2;
 #              $chaine ="$aa ($sc1) - $aa3 ($sc3) ";
 #          }
 #          elsif (($sc1 == $sc2) && ($sc2 == $sc3)) {
 #               $aa =$aa1.$aa2.$aa3;
 #               $chaine ="$aa ($sc1) ";
 #         }
 #         elsif ($sc2 == $sc3) {
 #              $aa =$aa2.$aa3;
 #              $chaine ="$aa1 ($sc1) - $aa ($sc2) ";
 #          }
 #          else{
 #              $chaine ="$aa1 ($sc1) - $aa2 ($sc2) - $aa3 ($sc3) ";
 #          }


	 if ($reponse eq "NO") {$chaine = "No result ";}
         return $chaine ;


 }# end fonction vote


sub trois2un {

	my ($v) = @_;
	$_ = $v;
s/GLY/G/g;
s/ALA/A/g;
s/VAL/V/g;
s/PHE/F/g;
s/ILE/I/g;
s/LEU/L/g;
s/PRO/P/g;
s/MET/M/g;
s/ASP/D/g;
s/GLU/E/g;
s/GLN/Q/g;
s/LYS/K/g;
s/ARG/R/g;
s/SER/S/g;
s/THR/T/g;
s/TYR/Y/g;
s/HIS/H/g;
s/CYS/C/g;
s/ASN/N/g;
s/TRP/W/g;
	
	return $_;
}

                  # Branchement des CSI


sub run_csi {

     my ($AFF_SHIFT,$AFF_VOTE) = @_;

# definition des fourchettes de deplacements chimiques pour les CSI
  $CA_CSI{"A"} = 52.5;
  $CA_CSI{"B"} = 58.3;
  $CA_CSI{"C"} = 58.0;
  $CA_CSI{"D"} = 54.2;
  $CA_CSI{"E"} = 56.6;
  $CA_CSI{"F"} = 57.7;
  $CA_CSI{"G"} = 45.1;
  $CA_CSI{"H"} = 55.0;
  $CA_CSI{"I"} = 61.1;
  $CA_CSI{"K"} = 56.2;
  $CA_CSI{"L"} = 55.1;
  $CA_CSI{"M"} = 55.4;
  $CA_CSI{"N"} = 53.1;
  $CA_CSI{"O"} = 56.7;
  $CA_CSI{"P"} = 62.9;
  $CA_CSI{"Q"} = 55.7;
  $CA_CSI{"R"} = 56.0;
  $CA_CSI{"S"} = 58.3;
  $CA_CSI{"T"} = 61.8;
  $CA_CSI{"V"} = 62.2;
  $CA_CSI{"W"} = 57.5;
  $CA_CSI{"Y"} = 57.9;

  $CB_CSI{"A"} = 19.1;
  $CB_CSI{"B"} = 28.6;
  $CB_CSI{"C"} = 41.8;
  $CB_CSI{"D"} = 41.1;
  $CB_CSI{"E"} = 29.9;
  $CB_CSI{"F"} = 39.6;
  $CB_CSI{"G"} = 00.0;
  $CB_CSI{"H"} = 32.0;
  $CB_CSI{"I"} = 38.8;
  $CB_CSI{"K"} = 33.1;
  $CB_CSI{"L"} = 42.4;
  $CB_CSI{"M"} = 32.9;
  $CB_CSI{"N"} = 38.9;
  $CB_CSI{"O"} = 32.3;
  $CB_CSI{"P"} = 31.7;
  $CB_CSI{"Q"} = 29.4;
  $CB_CSI{"R"} = 30.9;
  $CB_CSI{"S"} = 63.8;
  $CB_CSI{"T"} = 69.8;
  $CB_CSI{"V"} = 32.9;
  $CB_CSI{"W"} = 29.6;
  $CB_CSI{"Y"} = 37.8;

  $CO_CSI{"A"} = 177.8;
  $CO_CSI{"B"} = 174.8;
  $CO_CSI{"C"} = 175.1;
  $CO_CSI{"D"} = 176.3;
  $CO_CSI{"E"} = 176.6;
  $CO_CSI{"F"} = 175.8;
  $CO_CSI{"G"} = 174.9;
  $CO_CSI{"H"} = 174.1;
  $CO_CSI{"I"} = 176.4;
  $CO_CSI{"K"} = 176.6;
  $CO_CSI{"L"} = 177.6;
  $CO_CSI{"M"} = 176.3;
  $CO_CSI{"N"} = 175.2;
  $CO_CSI{"O"} = 176.5;
  $CO_CSI{"P"} = 177.3;
  $CO_CSI{"Q"} = 176.0;
  $CO_CSI{"R"} = 176.3;
  $CO_CSI{"S"} = 174.6;
  $CO_CSI{"T"} = 174.7;
  $CO_CSI{"V"} = 176.3;
  $CO_CSI{"W"} = 176.1;
  $CO_CSI{"Y"} = 175.9;


  $HA_CSI{"A"} = 4.32;
  $HA_CSI{"B"} = 4.55;
  $HA_CSI{"C"} = 4.65;
  $HA_CSI{"D"} = 4.64;
  $HA_CSI{"E"} = 4.35;
  $HA_CSI{"F"} = 4.62;
  $HA_CSI{"G"} = 3.96;
  $HA_CSI{"H"} = 4.63;
  $HA_CSI{"I"} = 4.17;
  $HA_CSI{"K"} = 4.32;
  $HA_CSI{"L"} = 4.34;
  $HA_CSI{"M"} = 4.48;
  $HA_CSI{"N"} = 4.74;
  $HA_CSI{"O"} = 4.36;
  $HA_CSI{"P"} = 4.42;
  $HA_CSI{"Q"} = 4.34;
  $HA_CSI{"R"} = 4.34;
  $HA_CSI{"S"} = 4.47;
  $HA_CSI{"T"} = 4.35;
  $HA_CSI{"V"} = 4.12;
  $HA_CSI{"W"} = 4.66;
  $HA_CSI{"Y"} = 4.55;

  $CA_CSI_ET = 2.0;
  $CB_CSI_ET = 2.5;
  $CO_CSI_ET = 2.0;
  $HA_CSI_ET = 0.38;


           # Recuperation des acides amines en sotie du VOTE


           $long_chaine = length($AFF_VOTE);
           $place = 1;
           for($u = 0;$u<$long_chaine;$u++){
                $carac = substr($AFF_VOTE,$u,1);
                $_ = $carac;
                if(/[A-Z]/){ $aa[$place] = $carac; $place++; }
           }


           #print ">$AFF_SHIFT<\n";
           @item = split(" ",$AFF_SHIFT);
           #if ($item[2]!="-") {
               $HA1 = $item[2];
               $HA2 = $item[3];
               $CA = $item[7];
               $CB = $item[8];
               $CO = $item[9];


         $chaine = "";
         # moyenne HA si le residu est une glycine:
         if (($aa[1] eq "G") && ($HA1!="-") && ($HA2!="-")){
         $HAt = ($HA1+$HA2);
         $HA = $HAt/2;

         }
         else {$HA = $HA1;}
         #premier residu
         $premier = $aa[1];
	 $csi1 = 0;
	 $csi2 = 0;
	 $csi3 = 0;

         # HA
         if ($HA ne "-") {
         $minHA = $HA_CSI{"$premier"} - $HA_CSI_ET;
         $maxHA = $HA_CSI{"$premier"} + $HA_CSI_ET;

         if ($HA < $minHA) { $Rep_HA_1 = "H"; $csi1 = $csi1 + 1;}
         elsif ($HA > $maxHA) {$Rep_HA_1 = "E"; $csi1 = $csi1 - 1;}
         else {$Rep_HA_1 = "C";}

          }else{$Rep_HA_1 = "-";}
         #CA
         if ($CA ne "-"){
         $minCA = $CA_CSI{"$premier"} - $CA_CSI_ET;
         $maxCA = $CA_CSI{"$premier"} + $CA_CSI_ET;

         if($CA < $minCA){ $Rep_CA_1 = "E"; $csi1 = $csi1 - 1;}
         elsif($CA >$maxCA) {$Rep_CA_1 = "H"; $csi1 = $csi1 + 1;}
         else {$Rep_CA_1 = "C";}
        }else{$Rep_CA_1 = "-";} 

        if ($CO ne "-"){
         # CO
         $minCO = $CO_CSI{"$premier"} - $CO_CSI_ET;
         $maxCO = $CO_CSI{"$premier"} + $CO_CSI_ET;

         if($CO < $minCO){ $Rep_CO_1 = "E"; $csi1 = $csi1 - 1; }
         elsif($CO >$maxCO) {$Rep_CO_1 = "H"; $csi1 = $csi1 + 1;}
         else {$Rep_CO_1 = "C";}
        } else{$Rep_CO_1 = "-";}

        if ($CB ne "-"){
         # CB
         $minCB = $CB_CSI{"$premier"} - $CB_CSI_ET;
         $maxCB = $CB_CSI{"$premier"} + 0.1;

         if($CB < $minCB){ $Rep_CB_1 = "H"; $csi1 = $csi1 + 1;}
         elsif($CB >$maxCB) {$Rep_CB_1 = "E"; $csi1 = $csi1 - 1;}
         else {$Rep_CB_1 = "C";}

       } else{$Rep_CB_1 = "-";}


         #Deuxieme residu
          if (($aa[2] eq "G")&& ($HA1!="-") && ($HA2!="-"))  {
         $HAt = ($HA1+$HA2);
         $HA = $HAt/2;

         }
         else {$HA = $HA1;}
         $second = $aa[2];
          if ($HA ne "-"){
         # HA

         $minHA = $HA_CSI{"$second"} - $HA_CSI_ET;
         $maxHA = $HA_CSI{"$second"} + $HA_CSI_ET;
         if ($HA < $minHA) { $Rep_HA_2 = "H"; $csi2 = $csi2 + 1;}
         elsif ($HA > $maxHA) {$Rep_HA_2 = "E";  $csi2 = $csi2 - 1;}
         else {$Rep_HA_2 = "C";}

        } else {$Rep_HA_2 = "-";}

          if ($CA ne "-"){
         #C
         $minCA = $CA_CSI{"$second"} - $CA_CSI_ET;
         $maxCA = $CA_CSI{"$second"} + $CA_CSI_ET;
         if($CA < $minCA){ $Rep_CA_2 = "E"; $csi2 = $csi2 - 1; }
         elsif($CA >$maxCA) {$Rep_CA_2 = "H"; $csi2 = $csi2 + 1;}
         else {$Rep_CA_2 = "C";}
         } else {$Rep_CA_2 = "-";}

         if ($CO ne "-"){
         # CO
         $minCO = $CO_CSI{"$second"} - $CO_CSI_ET;
         $maxCO = $CO_CSI{"$second"} + $CO_CSI_ET;
         if($CO < $minCO){ $Rep_CO_2 = "E"; $csi2 = $csi2 - 1; }
         elsif($CO >$maxCO) {$Rep_CO_2 = "H"; $csi2 = $csi2 + 1;}
         else {$Rep_CO_2 = "C";}
        } else {$Rep_CO_2 = "-";}

         if ($CB ne "-"){
         # CB
         $minCB = $CB_CSI{"$second"} - $CB_CSI_ET;
         $maxCB = $CB_CSI{"$second"} + 0.1;
         if($CB < $minCB){ $Rep_CB_2 = "H"; $csi2 = $csi2 + 1;}
         elsif($CB >$maxCB) {$Rep_CB_2 = "E"; $csi2 = $csi2 - 1; }
         else {$Rep_CB_2 = "C";}
        } else { $Rep_CB_2 = "-";}


          # Troisieme residu
     if (($aa[3] eq "G")&& ($HA1!="-") && ($HA2!="-"))    {
         $HAt = ($HA1+$HA2);
         $HA = $HAt/2;

         }
         else {$HA = $HA1;}
         $troisieme = $aa[2];


          if ($HA ne "-"){

         # HA
         $minHA = $HA_CSI{"$troisieme"} - $HA_CSI_ET;
         $maxHA = $HA_CSI{"$troisieme"} + $HA_CSI_ET;
         if ($HA < $minHA) { $Rep_HA_3 = "H"; $csi3 = $csi3 + 1;}
         elsif ($HA > $maxHA) {$Rep_HA_3 = "E"; $csi3 = $csi3 - 1;}
         else {$Rep_HA_3 = "C";}

        } else {$Rep_HA_3 = "-";}

         if ($CA ne "-"){
         #CA
         $minCA = $CA_CSI{"$troisieme"} - $CA_CSI_ET;
         $maxCA = $CA_CSI{"$troisieme"} + $CA_CSI_ET;
         if($CA < $minCA){ $Rep_CA_3 = "E";  $csi3 = $csi3 - 1;}
         elsif($CA >$maxCA) {$Rep_CA_3 = "H"; $csi3 = $csi3 + 1;}
         else {$Rep_CA_3 = "C";}
         } else {$Rep_CA_3 = "-";}

          if ($CO ne "-"){
         # CO
         $minCO = $CO_CSI{"$troisieme"} - $CO_CSI_ET;
         $maxCO = $CO_CSI{"$troisieme"} + $CO_CSI_ET;
         if($CO < $minCO){ $Rep_CO_3 = "E"; $csi3 = $csi3 - 1;}
         elsif($CO >$maxCO) {$Rep_CO_3 = "H"; $csi3 = $csi3 + 1;}
         else {$Rep_CO_3 = "C";}
         } else {$Rep_CO_3 = "-";}

          if ($CB ne "-"){
         # CB
         $minCB = $CB_CSI{"$troisieme"} - $CB_CSI_ET;
         $maxCB = $CB_CSI{"$troisieme"} + 0.1;
         if($CB < $minCB){ $Rep_CB_3 = "H"; $csi3 = $csi3 + 1;}
         elsif($CB >$maxCB) {$Rep_CB_3 = "E"; $csi3 = $csi3 - 1;}
         else {$Rep_CB_3 = "C";}
         } else {$Rep_CB_3 = "-";}

         # $chaine = $Rep_HA_1.$Rep_CA_1.$Rep_CB_1.$Rep_CO_1.$csi1."   ".$Rep_HA_2.$Rep_CA_2.$Rep_CB_2.$Rep_CO_2.$csi2."  ".$Rep_HA_3.$Rep_CA_3.$Rep_CB_3.$Rep_CO_3.$csi3;
	if($csi1 > 0){ $s2_1 = "H";} elsif($csi1 < 0){ $s2_1 = "E";} else {$s2_1 = "C";}
	if($csi2 > 0){ $s2_2 = "H";} elsif($csi2 < 0){ $s2_2 = "E";} else {$s2_2 = "C";}
	if($csi3 > 0){ $s2_3 = "H";} elsif($csi3 < 0){ $s2_3 = "E";} else {$s2_3 = "C";}
	$chaine = "$s2_1($csi1)     $s2_2($csi2)    $s2_3($csi3)";



    $AFF_CSI = $chaine;
    return $AFF_CSI;
}




